; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : the project name here
; File name : File name here
; File Version : 1.0.0
; Programmation : OK
; Programmed by : StarBootics
; Creation Date : 13-05-2016
; Last update : 13-05-2016
; Coded for : PureBasic 5.42 LTS
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Screen
  
  Declare.l GetWidth()
  Declare.l GetHeight()
  Declare.l GetDepth()
  Declare Initialize()
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare Open(P_Title.s)
  
EndDeclareModule

Module Screen

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Structure declaration <<<<<

  Structure Instance

    Width.l
    Height.l
    Depth.l
    Refresh.l

  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The observators <<<<<
  
  Procedure.l GetWidth()
    
    ProcedureReturn Instance\Width
  EndProcedure
  
  Procedure.l GetHeight()
    
    ProcedureReturn Instance\Height
  EndProcedure

  Procedure.l GetDepth()

    ProcedureReturn Instance\Depth
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Initialize operator <<<<<

  Procedure Initialize()
    
    ExamineDesktops()
    Instance\Width = DesktopWidth(0)
    Instance\Height = DesktopHeight(0)
    Instance\Depth = DesktopDepth(0)
    Instance\Refresh = 60
    
    If ExamineScreenModes()
      
      While NextScreenMode()
        
        Screen.Instance\Width = ScreenModeWidth()
        Screen\Height = ScreenModeHeight()
        Screen\Depth = ScreenModeDepth()
        Screen\Refresh = ScreenModeRefreshRate()
        
        If CompareMemory(Instance, Screen, SizeOf(Long) * 3)
          Success = #True
          Break
        EndIf
        
      Wend
      
      If Success = #False
        
        NewList Screen.Instance()
        
        If ExamineScreenModes()
          
          While NextScreenMode()
            AddElement(Screen())
            Screen()\Width = ScreenModeWidth()
            Screen()\Height = ScreenModeHeight()
            Screen()\Depth = ScreenModeDepth()
            Screen()\Refresh = ScreenModeRefreshRate()
          Wend
          
          ForEach Screen()
            
            Size = Screen()\Width * Screen()\Height
            
            If Size > Biggest
              Biggest = Size
              Index = ListIndex(Screen())
            EndIf
            
          Next
          
          If SelectElement(Screen(), Index)
            Instance\Width = Screen()\Width
            Instance\Height = Screen()\Height
            Instance\Depth = Screen()\Depth
            Instance\Refresh = Screen()\Refresh
            Success = #True
          EndIf
          
        EndIf   
        
        ClearList(Screen())
        
      EndIf
      
    EndIf
    
    ProcedureReturn Success
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Reset operator <<<<<

  Procedure Reset()
    
    Instance\Width = 0
    Instance\Height = 0
    Instance\Depth = 0
    Instance\Refresh = 0

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Read preferences group <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\Width = ReadPreferenceLong("Width", Instance\Width)
    Instance\Height = ReadPreferenceLong("Height", Instance\Height)
    Instance\Depth = ReadPreferenceLong("Depth", Instance\Depth)
    Instance\Refresh = ReadPreferenceLong("Refresh", Instance\Refresh)

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Write preferences group <<<<<

  Procedure WritePrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Width", Instance\Width)
    WritePreferenceLong("Height", Instance\Height)
    WritePreferenceLong("Depth", Instance\Depth)
    WritePreferenceLong("Refresh", Instance\Refresh)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< CreateScreen() <<<<<
  
  Procedure Open(P_Title.s)
    
    ProcedureReturn OpenScreen(Instance\Width, Instance\Height, Instance\Depth, P_Title)
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code generated in : 00.001 seconds (102000.00 lines/second) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory