; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Tempo
; Nom du fichier : Tempo - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 24-10-2008
; Mise  jour : 14-02-2015
; Cod pour PureBasic V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Tempo
  
  Declare New(P_TempoID.l, P_MilliSeconds.l, P_Seconds.l = 0, P_Minutes.l = 0, P_Hours.l = 0, P_Days.l = 0)
  Declare SetTime(P_TempoID.l, P_MilliSeconds.l, P_Seconds.l = 0, P_Minutes.l = 0, P_Hours.l = 0, P_Days.l = 0)
  Declare Reset(P_TempoID.l)
  Declare Start(P_TempoID.l)
  Declare Stop(P_TempoID.l)
  Declare.l Consult(P_TempoID.l)
  Declare.s Format(P_TempoID.l, TimeMask.s)
  
EndDeclareModule

Module Tempo
  
  Structure Instance
    
    ID.l
    StartTime.l
    TotalTime.l
    IsRunning.b
    
  EndStructure
  
  Global NewList Instances.Instance()
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Macros prives <<<<<
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Convertir des secondes en MS <<<<<
  
  Macro SecondsToMilliseconds(Seconds)
    
    (Seconds * 1000)
    
  EndMacro 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Convertir des minutes en MS <<<<<
  
  Macro MinutesToMilliseconds(Minutes)
    
    (Minutes * 60000)
    
  EndMacro 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Convertir des heures en MS <<<<<
  
  Macro HoursToMilliseconds(Hours)
    
    (Hours * 3600000)
    
  EndMacro 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Convertir des Jours en MS <<<<<
  
  Macro DaysToMilliseconds(Days)
    
    (Days * 86400000)
    
  EndMacro 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures prives <<<<<
  
  Procedure SearchInstances(P_TempoID.l)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach Instances()
      
      If Instances()\ID = P_TempoID
        IsFoundAtIndex = ListIndex(Instances())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures publiques <<<<<
  
  Procedure New(P_TempoID.l, P_MilliSeconds.l, P_Seconds.l = 0, P_Minutes.l = 0, P_Hours.l = 0, P_Days.l = 0)
    
    If SearchInstances(P_TempoID) = -1
      AddElement(Instances())
      Instances()\ID = P_TempoID
      Instances()\StartTime = 0
      Instances()\TotalTime = P_MilliSeconds + SecondsToMilliseconds(P_Seconds) + MinutesToMilliseconds(P_Minutes) + HoursToMilliseconds(P_Hours) + DaysToMilliseconds(P_Days)
      Instances()\IsRunning = #False
    EndIf
    
  EndProcedure
  
  Procedure SetTime(P_TempoID.l, P_MilliSeconds.l, P_Seconds.l = 0, P_Minutes.l = 0, P_Hours.l = 0, P_Days.l = 0)
    
    If SearchInstances(P_TempoID) <> -1
      Instances()\ID = P_TempoID
      Instances()\StartTime = 0
      Instances()\TotalTime = P_MilliSeconds + SecondsToMilliseconds(P_Seconds) + MinutesToMilliseconds(P_Minutes) + HoursToMilliseconds(P_Hours) + DaysToMilliseconds(P_Days)
      Instances()\IsRunning = #False
    EndIf
    
  EndProcedure
  
  Procedure Reset(P_TempoID.l)
    
    If P_TempoID = -1
      
      ForEach Instances()
        Instances()\ID = 0
        Instances()\StartTime = 0
        Instances()\TotalTime = 0
        Instances()\IsRunning = #False
      Next
      
      ClearList(Instances())
      
    Else
      
      If SearchInstances(P_TempoID) <> -1
        Instances()\ID = 0
        Instances()\StartTime = 0
        Instances()\TotalTime = 0
        Instances()\IsRunning = #False
        DeleteElement(Instances(), 1)
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure Start(P_TempoID.l)
    
    If SearchInstances(P_TempoID) <> -1
      If Instances()\IsRunning = #False
        Instances()\StartTime = ElapsedMilliseconds()
        Instances()\IsRunning = #True
      EndIf
    EndIf
    
  EndProcedure
  
  Procedure Stop(P_TempoID.l)
    
    If SearchInstances(P_TempoID) <> -1
      If Instances()\IsRunning = #True
        Instances()\TotalTime = Instances()\TotalTime - ElapsedMilliseconds() + Instances()\StartTime
        Instances()\IsRunning = #False
      EndIf
    EndIf
    
  EndProcedure
  
  Procedure.l Consult(P_TempoID.l)
    
    If SearchInstances(P_TempoID) <> -1
      If Instances()\IsRunning = #True
        TotalTime.l = Instances()\TotalTime - ElapsedMilliseconds() + Instances()\StartTime
      Else
        TotalTime = Instances()\TotalTime
      EndIf
    EndIf
    
    ProcedureReturn TotalTime
  EndProcedure
  
  Procedure.s Format(TempoID.l, TimeMask.s)
    
    If SearchInstances(P_TempoID) <> -1
      
      MilliSeconds = Consult(P_TempoID)
      
      ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ; <<<<< On fait l'extraction des jours, Heures, minutes, secondes et des MS <<<<<
      
      If MilliSeconds < 0 
        MilliSeconds = MilliSeconds * -1
      EndIf 
      
      Days = MilliSeconds / 86400000 
      MilliSeconds % 86400000
      
      Hours = MilliSeconds / 3600000
      MilliSeconds % 3600000
      
      Minutes = MilliSeconds / 60000
      MilliSeconds % 60000
      
      Seconds = MilliSeconds / 1000
      MilliSeconds % 1000
      
      ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ; <<<<< On s'occupe du filtre de sortie <<<<<
      
      If FindString(TimeMask, "%dd", 1)
        TimeMask = ReplaceString(TimeMask,"%dd", RSet(Str(Days), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%hh", 1)
        TimeMask = ReplaceString(TimeMask,"%hh", RSet(Str(Hours), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%mm", 1)
        TimeMask = ReplaceString(TimeMask,"%mm", RSet(Str(Minutes), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%ss", 1)
        TimeMask = ReplaceString(TimeMask,"%ss", RSet(Str(Seconds), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%mss", 1)
        TimeMask = ReplaceString(TimeMask,"%mss", RSet(Str(MilliSeconds), 3, "0"))
      EndIf
      
    EndIf
    
    ProcedureReturn TimeMask
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Tempo::New(0, 1500)
  Tempo::Start(0)
  
  Exit_Condition = #False
  
  While Exit_Condition = #False
    
    If Tempo::Consult(0) <= 0
      Tempo::Stop(0) 
      Exit_Condition = #True
    EndIf
    
  Wend

  Debug Tempo::Format(0, "%ss:%mss")
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory