; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Vector2 Module
; Nom du fichier : Vector2 - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 06-08-2007
; Mise  jour : 02-03-2015
; Code PureBasic : V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Vector2
  
  Structure Vector2
    i.f
    j.f
  EndStructure
  
  Declare.f GetI(*VectorA.Vector2)
  Declare.f GetJ(*VectorA.Vector2)
  Declare SetI(*VectorA.Vector2, P_i.f)
  Declare SetJ(*VectorA.Vector2, P_j.f)
  Declare Update(*VectorA.Vector2, P_i.f, P_j.f)
  Declare Reset(*VectorA.Vector2)
  Declare Copy(*VectorA.Vector2, *VectorB.Vector2)
  Declare Compare(*VectorA.Vector2, *VectorB.Vector2)
  Declare Swapping(*VectorA.Vector2, *VectorB.Vector2)
  Declare Plus(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
  Declare Minus(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
  Declare Zero(*VectorA.Vector2)
  Declare One(*VectorA.Vector2)
  Declare ProductByScalar(*VectorR.Vector2, *VectorA.Vector2, Scalar.f)
  Declare DivideByScalar(*VectorR.Vector2, *VectorA.Vector2, Scalar.f)
  Declare ReadVector2(FileID, *VectorA.Vector2)
  Declare WriteVector2(FileID, *VectorA.Vector2)
  Declare AddXMLAttribute(CurrentNode, *VectorA.Vector2)
  Declare CollectXMLAttribute(CurrentNode, *VectorA.Vector2)
  Declare.s Format(*VectorA.Vector2, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
  Declare Unformat(*VectorA.Vector2, P_Vector2.s, Brackets.s = "[]", Separator.s = ", ")
  Declare.f DotProduct(*VectorA.Vector2, *VectorB.Vector2)
  Declare.f Modulus(*VectorA.Vector2)
  Declare.f CrossProduct(*VectorA.Vector2, *VectorB.Vector2) 
  Declare MedianPosition(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
  Declare Lerp(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2, P_t.f)
  Declare AddScaled(*VectorR.Vector2, *VectorA.Vector2, Scale.f)
  Declare Unit(*VectorR.Vector2, *VectorA.Vector2 = #Null)
  
EndDeclareModule

Module Vector2
  
  Procedure.f GetI(*VectorA.Vector2)
    ProcedureReturn *VectorA\i
  EndProcedure
  
  Procedure.f GetJ(*VectorA.Vector2)
    ProcedureReturn *VectorA\j
  EndProcedure
  
  Procedure SetI(*VectorA.Vector2, P_i.f)
    *VectorA\i = P_i
  EndProcedure
  
  Procedure SetJ(*VectorA.Vector2, P_j.f)
    *VectorA\j = P_j
  EndProcedure
  
  Procedure Update(*VectorA.Vector2, P_i.f, P_j.f)
    *VectorA\i = P_i
    *VectorA\j = P_j
  EndProcedure
  
  Procedure Reset(*VectorA.Vector2)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
  EndProcedure
  
  Procedure Copy(*VectorA.Vector2, *VectorB.Vector2)
    *VectorB\i = *VectorA\i
    *VectorB\j = *VectorA\j
  EndProcedure
  
  Procedure Compare(*VectorA.Vector2, *VectorB.Vector2)
    
    ProcedureReturn CompareMemory(*VectorA, *VectorB, SizeOf(Vector2))
  EndProcedure
  
  Procedure Swapping(*VectorA.Vector2, *VectorB.Vector2)
    Swap *VectorA\i, *VectorB\i
    Swap *VectorA\j, *VectorB\j
  EndProcedure
  
  Procedure Plus(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
    *VectorR\i = *VectorA\i + *VectorB\i
    *VectorR\j = *VectorA\j + *VectorB\j
  EndProcedure
  
  Procedure Minus(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
    *VectorR\i = *VectorA\i - *VectorB\i
    *VectorR\j = *VectorA\j - *VectorB\j
  EndProcedure
  
  Procedure Zero(*VectorA.Vector2)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
  EndProcedure
  
  Procedure One(*VectorA.Vector2)
    *VectorA\i = 1.0
    *VectorA\j = 1.0
  EndProcedure
  
  Procedure ProductByScalar(*VectorR.Vector2, *VectorA.Vector2, Scalar.f)
    *VectorR\i = *VectorA\i * Scalar
    *VectorR\j = *VectorA\j * Scalar
  EndProcedure
  
  Procedure DivideByScalar(*VectorR.Vector2, *VectorA.Vector2, Scalar.f)
    *VectorR\i = *VectorA\i / Scalar
    *VectorR\j = *VectorA\j / Scalar
  EndProcedure
  
  Procedure ReadVector2(FileID, *VectorA.Vector2)
    *VectorA\i = ReadFloat(FileID)
    *VectorA\j = ReadFloat(FileID)
  EndProcedure
  
  Procedure WriteVector2(FileID, *VectorA.Vector2)
    WriteFloat(FileID, *VectorA\i)
    WriteFloat(FileID, *VectorA\j)
  EndProcedure
  
  Procedure AddXMLAttribute(CurrentNode, *VectorA.Vector2) 
    SetXMLAttribute(CurrentNode, "i", StrF(*VectorA\i, 6))
    SetXMLAttribute(CurrentNode, "j", StrF(*VectorA\j, 6))
  EndProcedure
  
  Procedure CollectXMLAttribute(CurrentNode, *VectorA.Vector2)
    *VectorA\i = ValF(GetXMLAttribute(CurrentNode, "i"))
    *VectorA\j = ValF(GetXMLAttribute(CurrentNode, "j"))
  EndProcedure

  Procedure.s Format(*VectorA.Vector2, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
    
    ProcedureReturn Mid(Brackets,1,1) + StrF(*VectorA\i, Decimal) + Separator + StrF(*VectorA\j, Decimal) + Mid(Brackets,2,1)
  EndProcedure
  
  Procedure Unformat(*VectorA.Vector2, P_Vector2.s, Brackets.s = "[]", Separator.s = ", ")
    
    *VectorA\i = ValF(StringField(StringField(StringField(P_Vector2, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 1, Separator))
    *VectorA\j = ValF(StringField(StringField(StringField(P_Vector2, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    
  EndProcedure
  
  Procedure.f DotProduct(*VectorA.Vector2, *VectorB.Vector2)
    
    ProcedureReturn *VectorA\i * *VectorB\i + *VectorA\j * *VectorB\j
  EndProcedure
  
  Procedure.f Modulus(*VectorA.Vector2)
    
    ProcedureReturn Sqr(*VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j)
  EndProcedure
  
  Procedure.f CrossProduct(*VectorA.Vector2, *VectorB.Vector2) 
    
    ProcedureReturn *VectorA\i * *VectorB\j + *VectorA\j * *VectorB\i
  EndProcedure
 
  Procedure MedianPosition(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2)
    *VectorR\i = (*VectorA\i + *VectorB\i) / 2.0
    *VectorR\j = (*VectorA\j + *VectorB\j) / 2.0
  EndProcedure
  
  Procedure Lerp(*VectorR.Vector2, *VectorA.Vector2, *VectorB.Vector2, P_t.f)
    *VectorR\i = *VectorA\i + P_t * (*VectorB\i - *VectorA\i) 
    *VectorR\j = *VectorA\j + P_t * (*VectorB\j - *VectorA\j)
  EndProcedure
  
  Procedure AddScaled(*VectorR.Vector2, *VectorA.Vector2, Scale.f)
    *VectorR\i = *VectorR\i + *VectorA\i * Scale
    *VectorR\j = *VectorR\j + *VectorA\j * Scale
  EndProcedure

  Procedure Unit(*VectorR.Vector2, *VectorA.Vector2 = #Null)
    
    ; Le calcule du module dans une variable tampon est ncessaire puisque
    ; l'criture et la lecture se fait dans la mme zone mmoire.
    ; Le calcul du module dpend de la valeur i et j du vecteur.

    If *VectorA <> #Null
      
      Unit_Vector2_Modulus.f = Modulus(*VectorA)
      
      If Unit_Vector2_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorA, Unit_Vector2_Modulus)
      EndIf 
      
    Else
      
      Unit_Vector2_Modulus.f = Modulus(*VectorR)
      
      If Unit_Vector2_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorR, Unit_Vector2_Modulus)
      EndIf 
      
    EndIf
    
  EndProcedure 
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Vector2::One(VecteurA.Vector2::Vector2)
  Vector2::One(VecteurB.Vector2::Vector2)  
  
  Debug Vector2::Compare(VecteurA, VecteurB)
  
  Vector2::Plus(VecteurR.Vector2::Vector2, VecteurA, VecteurB)
  
  Debug Vector2::Format(VecteurR)
  
  Debug ""
  Debug VecteurR\i
  Debug VecteurR\j
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = ------
; EnableUnicode
; EnableXP
; CompileSourceDirectory