; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : LOL - Animation
; Nom du fichier : LOL - Animation.pb
; Version du fichier : 3.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 13-05-2016
; Mise  jour : 13-05-2016
; Cod pour : PureBasic 5.42 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Animation
  
  Declare Initialize()
  Declare Reset()
  Declare InitializeEffex()
  Declare UpdateEffex()
  Declare Randomize()
  
EndDeclareModule

Module Animation
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration des Structures <<<<<
  
  Structure Flare
    
    Position.Vector2::Vector2
    Target.Vector2::Vector2
    Speed.Vector2::Vector2
    LinearSpeed.f
    Flag.b
    
  EndStructure
  
  Structure Instance
    
    ID.l
    List Flares.Flare()
    
  EndStructure
  
  Global NewList Instances.Instance()
  
  Procedure SearchInstances(P_InstanceID.l)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach Instances()
      
      If Instances()\ID = P_InstanceID
        IsFoundAtIndex = ListIndex(Instances())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.s DataRestore(P_Sequence.s)
    
    BlockCount = CountString(P_Sequence, ",") + 1
    
    For Index = 1 To BlockCount
      
      Count = Val(StringField(Trim(StringField(P_Sequence, Index, ",")), 1, ":"))
      Value.s = StringField(Trim(StringField(P_Sequence, Index, ",")), 2, ":")
      
      For Index2 = 1 To Count
        SequenceOut.s + Value
      Next
      
    Next
    
    ProcedureReturn SequenceOut
  EndProcedure

  Procedure CalculateFlareSpeedVector(*FlareA.Flare, P_x.f, P_y.f)
    
    Vector2::Update(*FlareA\Position, P_x, P_y)
    *FlareA\LinearSpeed = 2 + Random(3)
    *FlareA\Flag = 1
    
    Vector2::Minus(*FlareA\Speed, *FlareA\Target, *FlareA\Position)
    Vector2::Unit(*FlareA\Speed)
    Vector2::ProductByScalar(*FlareA\Speed, *FlareA\Speed, *FlareA\LinearSpeed)
    
  EndProcedure
  
  Procedure MoveFlare(*FlareA.Flare)
    
    DisplayTransparentSprite(0, Vector2::GetI(*FlareA\Position), Vector2::GetJ(*FlareA\Position))
    
    If *FlareA\Flag = 1
      
      Vector2::Plus(*FlareA\Position, *FlareA\Position, *FlareA\Speed)
      Vector2::Minus(Delta.Vector2::Vector2, *FlareA\Target, *FlareA\Position)
      
      DistanceTOTarget.d = Vector2::Modulus(Delta)
      
      If DistanceTOTarget <= 50.0
        
        Select DistanceTOTarget
            
          Case 45 To 50
            *FlareA\LinearSpeed = 1.75
            
          Case 40 To 44
            *FlareA\LinearSpeed = 1.50
            
          Case 35 To 39
            *FlareA\LinearSpeed = 1.25
            
          Case 30 To 34
            *FlareA\LinearSpeed = 1.00
            
          Default 
            *FlareA\LinearSpeed = 0.75
            
        EndSelect 
        
      EndIf
      
      Vector2::Minus(*FlareA\Speed, *FlareA\Target, *FlareA\Position)
      Vector2::Unit(*FlareA\Speed)
      Vector2::ProductByScalar(*FlareA\Speed, *FlareA\Speed, *FlareA\LinearSpeed)
      
      If DistanceTOTarget <= 0.1
        *FlareA\Flag = 0
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure MakeBackground(AnimationID, ScreenW, ScreenH)
    
    Shared Color.l,Count.l,FlareI.l
    Protected Index
    
    Select AnimationID
        
      Case 0
        Restore BG_Animation_00:
        
      Case 1
        Restore BG_Animation_01:
        
      Case 2
        Restore BG_Animation_02:
        
      Case 3
        Restore BG_Animation_03: 
        
    EndSelect
    
    PosX = (ScreenW - 1024) >> 1
    PosY = (ScreenH - 768) >> 1
    
    For Y = PosY To PosY + 767 Step 4
      
      Read.s Line.s
      
      Index = 1
      Sequence.s = DataRestore(Line)
      
      For X = PosX To PosX + 1023 Step 4
        
        If Val(Mid(Sequence, Index, 1)) = 1
          AddElement(Instances()\Flares())
          Vector2::Update(Instances()\Flares()\Target, X, Y)
        EndIf
        
        Index + 1
        
      Next
      
    Next
    
  EndProcedure
  
  Procedure MakeFlare()
    
    PS = 6
    Size = PS << 1
    
    If CreateSprite(0, Size, Size)
      
      TransparentSpriteColor(0, 0)
      
      If StartDrawing(SpriteOutput(0))
        
        Box(0,0, Size, Size, 0)
        Cxy = PS
        
        For Radius = 0 To PS
          Circle(Cxy, Cxy, PS - Radius, RGB(COLORV >> 1, COLORV >> 1, COLORV))
          COLORV = Int(LinearlySpacedValue::Float(Radius, PS, 0, 255))
        Next
        
        StopDrawing() 
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure InitializeEffex()
    
    ForEach Instances()\Flares()
      CalculateFlareSpeedVector(Instances()\Flares(), Random(Screen::GetWidth()), Random(Screen::GetHeight())) 
    Next
    
  EndProcedure
  
  Procedure Initialize()
    
    MakeFlare()
    
    For AnimationID = 0 To 3
      AddElement(Instances())
      MakeBackground(AnimationID, Screen::GetWidth(), Screen::GetHeight())
      InitializeEffex()
    Next
    
  EndProcedure
  
  Procedure Reset()
    
    ForEach Instances()
      
      Instances()\ID = 0
      
      ForEach Instances()\Flares()
        Vector2::Reset(Instances()\Flares()\Position)
        Vector2::Reset(Instances()\Flares()\Target)
        Vector2::Reset(Instances()\Flares()\Speed)
        Instances()\Flares()\LinearSpeed = 0.0
        Instances()\Flares()\Flag = 0
      Next
      
      FreeList(Instances()\Flares())
      
    Next
    
    FreeList(Instances())
    
  EndProcedure
  
  Procedure UpdateEffex()
    
    ForEach Instances()\Flares()
      MoveFlare(Instances()\Flares())
    Next
    
  EndProcedure
  
  Procedure Randomize()
    
    Static LastRandom = -1
    
    While Exit = #False
      
      Number = Random(ListSize(Instances()) - 1)
      
      If Number <> LastRandom
        Exit = #True
        LastRandom = Number
      EndIf
      
    Wend
    
    SelectElement(Instances(), Number)
    
  EndProcedure
  
  
  DataSection
    
    BG_Animation_00:
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "81:0, 7:1, 168:0"
    Data.s "78:0, 16:1, 162:0"
    Data.s "77:0, 19:1, 160:0"
    Data.s "75:0, 22:1, 159:0"
    Data.s "48:0, 7:1, 20:0, 24:1, 157:0"
    Data.s "45:0, 12:1, 17:0, 26:1, 156:0"
    Data.s "42:0, 17:1, 14:0, 27:1, 156:0"
    Data.s "40:0, 20:1, 13:0, 10:1, 4:0, 14:1, 155:0"
    Data.s "38:0, 23:1, 11:0, 9:1, 11:0, 9:1, 155:0"
    Data.s "37:0, 25:1, 10:0, 8:1, 13:0, 8:1, 155:0"
    Data.s "36:0, 26:1, 10:0, 7:1, 15:0, 8:1, 39:0, 6:1, 24:0, 8:1, 77:0"
    Data.s "35:0, 15:1, 3:0, 10:1, 9:0, 7:1, 16:0, 7:1, 37:0, 9:1, 21:0, 12:1, 75:0"
    Data.s "35:0, 11:1, 9:0, 8:1, 32:0, 7:1, 37:0, 11:1, 17:0, 16:1, 73:0"
    Data.s "34:0, 10:1, 12:0, 8:1, 31:0, 7:1, 37:0, 12:1, 15:0, 19:1, 71:0"
    Data.s "34:0, 8:1, 14:0, 8:1, 31:0, 7:1, 38:0, 3:1, 2:0, 7:1, 13:0, 22:1, 69:0"
    Data.s "34:0, 8:1, 15:0, 7:1, 30:0, 8:1, 45:0, 5:1, 13:0, 24:1, 27:0, 11:1, 29:0"
    Data.s "34:0, 7:1, 16:0, 7:1, 29:0, 9:1, 46:0, 4:1, 12:0, 25:1, 25:0, 14:1, 28:0"
    Data.s "34:0, 7:1, 15:0, 8:1, 28:0, 9:1, 47:0, 5:1, 11:0, 9:1, 4:0, 13:1, 23:0, 17:1, 26:0"
    Data.s "34:0, 7:1, 15:0, 8:1, 27:0, 10:1, 48:0, 4:1, 13:0, 6:1, 7:0, 12:1, 21:0, 19:1, 25:0"
    Data.s "34:0, 7:1, 14:0, 8:1, 26:0, 11:1, 48:0, 5:1, 15:0, 3:1, 10:0, 11:1, 19:0, 20:1, 25:0"
    Data.s "34:0, 7:1, 14:0, 8:1, 25:0, 12:1, 45:0, 7:1, 31:0, 9:1, 18:0, 22:1, 24:0"
    Data.s "34:0, 4:1, 16:0, 8:1, 25:0, 12:1, 40:0, 13:1, 32:0, 8:1, 17:0, 11:1, 2:0, 10:1, 24:0"
    Data.s "54:0, 8:1, 24:0, 11:1, 42:0, 12:1, 34:0, 7:1, 16:0, 10:1, 6:0, 9:1, 23:0"
    Data.s "53:0, 8:1, 23:0, 12:1, 42:0, 12:1, 35:0, 8:1, 14:0, 10:1, 8:0, 8:1, 23:0"
    Data.s "53:0, 8:1, 22:0, 12:1, 42:0, 9:1, 40:0, 7:1, 13:0, 10:1, 10:0, 7:1, 23:0"
    Data.s "52:0, 8:1, 22:0, 12:1, 44:0, 4:1, 44:0, 7:1, 13:0, 9:1, 11:0, 7:1, 23:0"
    Data.s "52:0, 8:1, 22:0, 10:1, 47:0, 2:1, 44:0, 8:1, 12:0, 9:1, 12:0, 7:1, 23:0"
    Data.s "51:0, 8:1, 23:0, 9:1, 22:0, 5:1, 17:0, 3:1, 47:0, 7:1, 13:0, 8:1, 13:0, 7:1, 23:0"
    Data.s "51:0, 8:1, 22:0, 9:1, 21:0, 8:1, 16:0, 3:1, 46:0, 8:1, 13:0, 7:1, 14:0, 7:1, 23:0"
    Data.s "50:0, 9:1, 22:0, 8:1, 20:0, 11:1, 15:0, 3:1, 44:0, 10:1, 13:0, 7:1, 14:0, 7:1, 23:0"
    Data.s "22:0, 6:1, 22:0, 8:1, 23:0, 7:1, 20:0, 13:1, 14:0, 3:1, 41:0, 12:1, 14:0, 7:1, 14:0, 7:1, 23:0"
    Data.s "21:0, 9:1, 20:0, 8:1, 23:0, 7:1, 19:0, 7:1, 2:0, 5:1, 55:0, 15:1, 14:0, 7:1, 14:0, 7:1, 23:0"
    Data.s "20:0, 12:1, 18:0, 8:1, 23:0, 7:1, 19:0, 6:1, 4:0, 5:1, 51:0, 17:1, 15:0, 7:1, 14:0, 7:1, 23:0"
    Data.s "19:0, 14:1, 17:0, 8:1, 23:0, 7:1, 18:0, 5:1, 6:0, 5:1, 48:0, 20:1, 15:0, 8:1, 13:0, 7:1, 23:0"
    Data.s "20:0, 4:1, 2:0, 7:1, 18:0, 7:1, 48:0, 4:1, 7:0, 4:1, 47:0, 20:1, 17:0, 8:1, 13:0, 7:1, 23:0"
    Data.s "28:0, 6:1, 17:0, 8:1, 47:0, 4:1, 7:0, 4:1, 47:0, 18:1, 19:0, 8:1, 13:0, 7:1, 23:0"
    Data.s "29:0, 5:1, 17:0, 8:1, 47:0, 5:1, 6:0, 4:1, 46:0, 17:1, 22:0, 6:1, 14:0, 7:1, 23:0"
    Data.s "30:0, 4:1, 18:0, 3:1, 52:0, 3:1, 6:0, 5:1, 46:0, 14:1, 25:0, 5:1, 15:0, 7:1, 23:0"
    Data.s "30:0, 4:1, 47:0, 5:1, 21:0, 2:1, 7:0, 4:1, 46:0, 12:1, 29:0, 3:1, 16:0, 8:1, 22:0"
    Data.s "28:0, 6:1, 46:0, 7:1, 29:0, 4:1, 46:0, 9:1, 33:0, 1:1, 17:0, 9:1, 21:0"
    Data.s "26:0, 7:1, 47:0, 7:1, 29:0, 4:1, 45:0, 8:1, 53:0, 10:1, 20:0"
    Data.s "23:0, 10:1, 23:0, 4:1, 20:0, 7:1, 29:0, 5:1, 45:0, 7:1, 54:0, 9:1, 20:0"
    Data.s "21:0, 11:1, 23:0, 6:1, 19:0, 7:1, 29:0, 5:1, 47:0, 4:1, 56:0, 8:1, 20:0"
    Data.s "21:0, 9:1, 24:0, 7:1, 19:0, 6:1, 31:0, 3:1, 50:0, 2:1, 57:0, 6:1, 21:0"
    Data.s "20:0, 7:1, 27:0, 7:1, 20:0, 4:1, 145:0, 4:1, 22:0"
    Data.s "20:0, 4:1, 30:0, 7:1, 59:0, 3:1, 108:0, 2:1, 23:0"
    Data.s "21:0, 3:1, 31:0, 6:1, 59:0, 4:1, 39:0, 4:1, 70:0, 5:1, 14:0"
    Data.s "55:0, 5:1, 60:0, 3:1, 39:0, 6:1, 68:0, 7:1, 13:0"
    Data.s "18:0, 4:1, 99:0, 1:1, 39:0, 7:1, 68:0, 7:1, 13:0"
    Data.s "18:0, 4:1, 139:0, 7:1, 68:0, 7:1, 13:0"
    Data.s "18:0, 4:1, 140:0, 6:1, 68:0, 7:1, 13:0"
    Data.s "18:0, 3:1, 141:0, 6:1, 69:0, 5:1, 14:0"
    Data.s "163:0, 4:1, 71:0, 2:1, 16:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 7:0, 4:1, 20:0, 12:1, 6:0, 4:1, 7:0, 4:1, 2:0, 13:1, 5:0, 16:1, 2:0, 12:1, 9:0, 8:1, 10:0, 8:1, 6:0, 15:1, 6:0, 8:1, 9:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 5:1, 6:0, 4:1, 20:0, 14:1, 4:0, 4:1, 7:0, 4:1, 2:0, 14:1, 4:0, 16:1, 2:0, 13:1, 7:0, 11:1, 6:0, 12:1, 4:0, 15:1, 4:0, 12:1, 7:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 5:1, 6:0, 4:1, 20:0, 15:1, 3:0, 4:1, 7:0, 4:1, 2:0, 15:1, 3:0, 16:1, 2:0, 14:1, 5:0, 13:1, 4:0, 14:1, 3:0, 15:1, 4:0, 13:1, 6:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 6:1, 5:0, 4:1, 20:0, 15:1, 3:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 16:1, 2:0, 15:1, 3:0, 15:1, 3:0, 14:1, 3:0, 15:1, 3:0, 15:1, 5:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 6:1, 5:0, 4:1, 20:0, 4:1, 6:0, 6:1, 2:0, 4:1, 7:0, 4:1, 2:0, 4:1, 7:0, 5:1, 2:0, 4:1, 14:0, 4:1, 6:0, 5:1, 2:0, 6:1, 5:0, 5:1, 2:0, 5:1, 6:0, 5:1, 8:0, 4:1, 8:0, 5:1, 5:0, 5:1, 5:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 7:1, 4:0, 4:1, 20:0, 4:1, 7:0, 5:1, 2:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 5:1, 7:0, 4:1, 2:0, 4:1, 7:0, 5:1, 8:0, 4:1, 7:0, 5:1, 7:0, 4:1, 5:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 8:1, 3:0, 4:1, 20:0, 4:1, 8:0, 4:1, 2:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 7:0, 4:1, 8:0, 4:1, 5:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 8:1, 3:0, 4:1, 20:0, 4:1, 7:0, 5:1, 2:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 5:1, 19:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 9:1, 2:0, 4:1, 20:0, 4:1, 6:0, 5:1, 3:0, 4:1, 7:0, 4:1, 2:0, 4:1, 6:0, 6:1, 2:0, 4:1, 14:0, 4:1, 6:0, 5:1, 2:0, 4:1, 8:0, 4:1, 2:0, 5:1, 19:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 16:1, 2:0, 13:1, 5:0, 9:1, 2:0, 4:1, 20:0, 15:1, 3:0, 4:1, 7:0, 4:1, 2:0, 15:1, 3:0, 13:1, 5:0, 15:1, 2:0, 4:1, 8:0, 4:1, 3:0, 12:1, 11:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 16:1, 2:0, 13:1, 5:0, 4:1, 1:0, 5:1, 1:0, 4:1, 20:0, 14:1, 4:0, 4:1, 7:0, 4:1, 2:0, 15:1, 3:0, 13:1, 5:0, 14:1, 3:0, 4:1, 8:0, 4:1, 3:0, 13:1, 10:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 16:1, 2:0, 13:1, 5:0, 4:1, 1:0, 5:1, 1:0, 4:1, 20:0, 14:1, 4:0, 4:1, 7:0, 4:1, 2:0, 15:1, 3:0, 13:1, 5:0, 14:1, 3:0, 4:1, 8:0, 4:1, 4:0, 13:1, 9:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 16:1, 2:0, 13:1, 5:0, 4:1, 2:0, 9:1, 20:0, 12:1, 6:0, 4:1, 7:0, 4:1, 2:0, 15:1, 3:0, 13:1, 5:0, 15:1, 2:0, 16:1, 6:0, 11:1, 9:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 3:0, 8:1, 20:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 7:0, 5:1, 2:0, 4:1, 14:0, 4:1, 6:0, 5:1, 2:0, 16:1, 13:0, 5:1, 8:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 3:0, 8:1, 20:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 16:1, 14:0, 4:1, 8:0, 4:1, 7:0, 4:1, 17:0"
    Data.s "6:0, 4:1, 1:0, 5:1, 1:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 4:0, 7:1, 20:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 7:0, 4:1, 8:0, 4:1, 5:0"
    Data.s "6:0, 4:1, 1:0, 5:1, 1:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 4:0, 7:1, 20:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 7:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 5:1, 6:0, 5:1, 8:0, 4:1, 7:0, 5:1, 7:0, 4:1, 5:0"
    Data.s "6:0, 15:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 5:0, 6:1, 20:0, 4:1, 14:0, 5:1, 5:0, 5:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 6:0, 5:1, 2:0, 4:1, 8:0, 4:1, 2:0, 6:1, 4:0, 5:1, 9:0, 4:1, 8:0, 5:1, 5:0, 5:1, 5:0"
    Data.s "6:0, 15:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 5:0, 6:1, 20:0, 4:1, 14:0, 15:1, 2:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 15:1, 2:0, 4:1, 8:0, 4:1, 3:0, 14:1, 3:0, 15:1, 3:0, 14:1, 6:0"
    Data.s "7:0, 13:1, 3:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 6:0, 5:1, 20:0, 4:1, 15:0, 13:1, 3:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 14:1, 3:0, 4:1, 8:0, 4:1, 3:0, 14:1, 3:0, 15:1, 4:0, 13:1, 6:0"
    Data.s "8:0, 5:1, 1:0, 5:1, 4:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 7:0, 4:1, 20:0, 4:1, 16:0, 11:1, 4:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 13:1, 4:0, 4:1, 8:0, 4:1, 4:0, 11:1, 5:0, 15:1, 5:0, 11:1, 7:0"
    Data.s "9:0, 3:1, 3:0, 3:1, 5:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 7:0, 4:1, 20:0, 4:1, 18:0, 7:1, 6:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 11:1, 6:0, 4:1, 8:0, 4:1, 6:0, 8:1, 6:0, 15:1, 7:0, 6:1, 10:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "16:0, 4:1, 8:0, 4:1, 2:0, 14:1, 21:0, 15:1, 7:0, 7:1, 24:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 13:0, 4:1, 32:0, 11:1, 6:0, 16:1, 12:0"
    Data.s "16:0, 5:1, 6:0, 5:1, 2:0, 14:1, 21:0, 15:1, 5:0, 11:1, 22:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 13:0, 4:1, 32:0, 13:1, 4:0, 16:1, 12:0"
    Data.s "16:0, 5:1, 6:0, 5:1, 2:0, 14:1, 21:0, 15:1, 4:0, 13:1, 21:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 13:0, 4:1, 32:0, 14:1, 3:0, 16:1, 12:0"
    Data.s "17:0, 4:1, 6:0, 4:1, 3:0, 14:1, 21:0, 15:1, 4:0, 14:1, 20:0, 4:1, 8:0, 4:1, 2:0, 16:1, 2:0, 4:1, 13:0, 4:1, 32:0, 15:1, 2:0, 16:1, 12:0"
    Data.s "17:0, 4:1, 6:0, 4:1, 3:0, 4:1, 31:0, 4:1, 14:0, 6:1, 4:0, 5:1, 20:0, 4:1, 8:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 6:0, 5:1, 2:0, 4:1, 24:0"
    Data.s "17:0, 5:1, 4:0, 5:1, 3:0, 4:1, 31:0, 4:1, 14:0, 4:1, 7:0, 5:1, 19:0, 4:1, 8:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "18:0, 4:1, 4:0, 4:1, 4:0, 12:1, 23:0, 12:1, 6:0, 4:1, 8:0, 4:1, 19:0, 4:1, 8:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "18:0, 4:1, 4:0, 4:1, 4:0, 13:1, 22:0, 14:1, 4:0, 4:1, 8:0, 4:1, 19:0, 4:1, 8:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "18:0, 5:1, 2:0, 5:1, 4:0, 14:1, 21:0, 15:1, 3:0, 4:1, 8:0, 4:1, 19:0, 4:1, 8:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 6:0, 5:1, 2:0, 4:1, 24:0"
    Data.s "19:0, 4:1, 2:0, 4:1, 5:0, 15:1, 20:0, 15:1, 3:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 15:1, 2:0, 13:1, 15:0"
    Data.s "19:0, 4:1, 2:0, 4:1, 15:0, 5:1, 31:0, 5:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 14:1, 3:0, 13:1, 15:0"
    Data.s "19:0, 5:1, 1:0, 4:1, 16:0, 5:1, 31:0, 4:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 14:1, 3:0, 13:1, 15:0"
    Data.s "19:0, 10:1, 17:0, 4:1, 31:0, 4:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 15:1, 2:0, 13:1, 15:0"
    Data.s "20:0, 8:1, 18:0, 4:1, 31:0, 4:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 6:0, 5:1, 2:0, 4:1, 24:0"
    Data.s "20:0, 8:1, 18:0, 4:1, 31:0, 4:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "20:0, 8:1, 6:0, 4:1, 8:0, 4:1, 19:0, 4:1, 8:0, 4:1, 2:0, 4:1, 8:0, 4:1, 19:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "21:0, 7:1, 6:0, 4:1, 7:0, 5:1, 19:0, 5:1, 7:0, 4:1, 2:0, 4:1, 7:0, 5:1, 19:0, 5:1, 1:0, 5:1, 1:0, 4:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 7:0, 4:1, 2:0, 4:1, 24:0"
    Data.s "21:0, 6:1, 7:0, 5:1, 5:0, 5:1, 8:0, 5:1, 7:0, 6:1, 4:0, 6:1, 2:0, 5:1, 5:0, 5:1, 20:0, 16:1, 8:0, 4:1, 8:0, 4:1, 13:0, 4:1, 32:0, 4:1, 6:0, 5:1, 2:0, 4:1, 24:0"
    Data.s "21:0, 6:1, 8:0, 14:1, 8:0, 5:1, 8:0, 14:1, 3:0, 15:1, 21:0, 14:1, 3:0, 16:1, 2:0, 15:1, 2:0, 16:1, 20:0, 15:1, 2:0, 16:1, 12:0"
    Data.s "21:0, 6:1, 8:0, 13:1, 9:0, 5:1, 9:0, 13:1, 4:0, 13:1, 22:0, 14:1, 3:0, 16:1, 2:0, 15:1, 2:0, 16:1, 20:0, 14:1, 3:0, 16:1, 12:0"
    Data.s "22:0, 5:1, 9:0, 12:1, 9:0, 5:1, 9:0, 12:1, 6:0, 11:1, 24:0, 12:1, 4:0, 16:1, 2:0, 15:1, 2:0, 16:1, 20:0, 13:1, 4:0, 16:1, 12:0"
    Data.s "22:0, 4:1, 12:0, 7:1, 13:0, 3:1, 12:0, 8:1, 10:0, 8:1, 26:0, 4:1, 2:0, 4:1, 5:0, 16:1, 2:0, 15:1, 2:0, 16:1, 20:0, 11:1, 6:0, 16:1, 12:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "44:0, 13:1, 4:0, 16:1, 2:0, 4:1, 14:0, 15:1, 5:0, 11:1, 7:0, 10:1, 5:0, 15:1, 2:0, 13:1, 25:0, 11:1, 40:0"
    Data.s "44:0, 14:1, 3:0, 16:1, 2:0, 4:1, 14:0, 15:1, 4:0, 13:1, 4:0, 13:1, 4:0, 15:1, 2:0, 15:1, 22:0, 13:1, 39:0"
    Data.s "44:0, 15:1, 2:0, 16:1, 2:0, 4:1, 14:0, 15:1, 3:0, 14:1, 4:0, 14:1, 3:0, 15:1, 2:0, 15:1, 22:0, 14:1, 38:0"
    Data.s "44:0, 4:1, 5:0, 6:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 14:0, 5:1, 4:0, 6:1, 2:0, 6:1, 3:0, 6:1, 3:0, 4:1, 13:0, 4:1, 6:0, 6:1, 20:0, 6:1, 3:0, 6:1, 38:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 5:1, 6:0, 5:1, 2:0, 5:1, 6:0, 5:1, 2:0, 4:1, 13:0, 4:1, 7:0, 5:1, 20:0, 4:1, 7:0, 4:1, 38:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 13:0, 4:1, 8:0, 4:1, 20:0, 4:1, 7:0, 4:1, 38:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 2:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 31:0, 4:1, 38:0"
    Data.s "44:0, 4:1, 6:0, 5:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 2:0, 5:1, 13:0, 4:1, 13:0, 4:1, 8:0, 4:1, 30:0, 5:1, 38:0"
    Data.s "44:0, 15:1, 2:0, 13:1, 5:0, 4:1, 14:0, 12:1, 5:0, 4:1, 8:0, 4:1, 2:0, 11:1, 7:0, 12:1, 5:0, 4:1, 8:0, 4:1, 29:0, 6:1, 38:0"
    Data.s "44:0, 14:1, 3:0, 13:1, 5:0, 4:1, 14:0, 12:1, 5:0, 4:1, 8:0, 4:1, 3:0, 12:1, 5:0, 12:1, 5:0, 4:1, 8:0, 4:1, 28:0, 6:1, 39:0"
    Data.s "44:0, 14:1, 3:0, 13:1, 5:0, 4:1, 14:0, 12:1, 5:0, 4:1, 8:0, 4:1, 4:0, 12:1, 4:0, 12:1, 5:0, 4:1, 8:0, 4:1, 27:0, 6:1, 40:0"
    Data.s "44:0, 15:1, 2:0, 13:1, 5:0, 4:1, 14:0, 12:1, 5:0, 16:1, 5:0, 12:1, 3:0, 12:1, 5:0, 4:1, 8:0, 4:1, 26:0, 6:1, 41:0"
    Data.s "44:0, 4:1, 6:0, 5:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 16:1, 12:0, 6:1, 2:0, 4:1, 13:0, 4:1, 8:0, 4:1, 26:0, 5:1, 42:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 16:1, 13:0, 5:1, 2:0, 4:1, 13:0, 4:1, 8:0, 4:1, 26:0, 4:1, 43:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 16:1, 2:0, 4:1, 8:0, 4:1, 2:0, 4:1, 13:0, 4:1, 8:0, 4:1, 26:0, 4:1, 43:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 2:0, 4:1, 7:0, 5:1, 2:0, 4:1, 13:0, 4:1, 8:0, 4:1, 26:0, 4:1, 43:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 4:1, 14:0, 4:1, 14:0, 4:1, 13:0, 4:1, 8:0, 4:1, 2:0, 5:1, 6:0, 5:1, 2:0, 4:1, 13:0, 4:1, 7:0, 5:1, 26:0, 4:1, 43:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 16:1, 2:0, 15:1, 2:0, 4:1, 8:0, 4:1, 3:0, 14:1, 3:0, 15:1, 2:0, 16:1, 73:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 16:1, 2:0, 15:1, 2:0, 4:1, 8:0, 4:1, 3:0, 14:1, 3:0, 15:1, 2:0, 15:1, 27:0, 3:1, 44:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 16:1, 2:0, 15:1, 2:0, 4:1, 8:0, 4:1, 4:0, 12:1, 4:0, 15:1, 2:0, 14:1, 28:0, 4:1, 43:0"
    Data.s "44:0, 4:1, 7:0, 4:1, 2:0, 16:1, 2:0, 16:1, 2:0, 15:1, 2:0, 4:1, 8:0, 4:1, 5:0, 9:1, 6:0, 15:1, 2:0, 13:1, 29:0, 4:1, 43:0"
    Data.s "209:0, 3:1, 44:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    
    BG_Animation_01:
    
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "19:0, 4:1, 1:0, 6:1, 8:0, 4:1, 7:0, 4:1, 4:0, 4:1, 2:0, 5:1, 12:0, 6:1, 8:0, 4:1, 2:0, 5:1, 14:0, 3:1, 15:0, 6:1, 11:0, 9:1, 11:0, 6:1, 76:0"
    Data.s "19:0, 4:1, 1:0, 7:1, 7:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 7:1, 10:0, 8:1, 7:0, 5:1, 1:0, 6:1, 13:0, 4:1, 13:0, 8:1, 10:0, 9:1, 10:0, 8:1, 75:0"
    Data.s "19:0, 13:1, 6:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 8:1, 8:0, 10:1, 6:0, 4:1, 1:0, 8:1, 11:0, 5:1, 12:0, 10:1, 9:0, 9:1, 9:0, 10:1, 74:0"
    Data.s "19:0, 14:1, 5:0, 4:1, 7:0, 4:1, 4:0, 14:1, 6:0, 12:1, 5:0, 4:1, 1:0, 9:1, 10:0, 6:1, 10:0, 12:1, 8:0, 9:1, 8:0, 12:1, 73:0"
    Data.s "19:0, 7:1, 3:0, 5:1, 4:0, 4:1, 7:0, 4:1, 4:0, 8:1, 1:0, 6:1, 4:0, 6:1, 3:0, 5:1, 4:0, 8:1, 2:0, 5:1, 9:0, 7:1, 8:0, 5:1, 3:0, 6:1, 9:0, 5:1, 9:0, 6:1, 3:0, 5:1, 72:0"
    Data.s "19:0, 7:1, 4:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 7:1, 3:0, 5:1, 4:0, 5:1, 5:0, 5:1, 3:0, 8:1, 3:0, 5:1, 7:0, 8:1, 7:0, 5:1, 5:0, 5:1, 9:0, 5:1, 9:0, 4:1, 6:0, 5:1, 71:0"
    Data.s "19:0, 6:1, 6:0, 4:1, 3:0, 4:1, 7:0, 4:1, 4:0, 7:1, 4:0, 4:1, 4:0, 4:1, 7:0, 3:1, 4:0, 7:1, 5:0, 4:1, 6:0, 4:1, 1:0, 4:1, 7:0, 4:1, 7:0, 3:1, 10:0, 5:1, 9:0, 3:1, 8:0, 3:1, 72:0"
    Data.s "19:0, 6:1, 6:0, 4:1, 3:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 4:1, 4:0, 4:1, 8:0, 1:1, 5:0, 7:1, 5:0, 4:1, 6:0, 4:1, 2:0, 4:1, 6:0, 4:1, 8:0, 1:1, 11:0, 5:1, 9:0, 3:1, 9:0, 1:1, 73:0"
    Data.s "19:0, 5:1, 7:0, 4:1, 3:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 4:1, 4:0, 4:1, 14:0, 6:1, 6:0, 4:1, 5:0, 5:1, 2:0, 5:1, 5:0, 4:1, 20:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 6:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 5:1, 6:0, 4:1, 4:0, 4:1, 14:0, 6:1, 5:0, 5:1, 5:0, 4:1, 4:0, 4:1, 5:0, 5:1, 19:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 5:0, 5:1, 4:0, 4:1, 7:0, 4:1, 4:0, 5:1, 5:0, 5:1, 4:0, 6:1, 12:0, 5:1, 5:0, 6:1, 4:0, 4:1, 5:0, 4:1, 5:0, 6:1, 18:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 14:1, 5:0, 4:1, 7:0, 4:1, 4:0, 4:1, 2:0, 8:1, 6:0, 10:1, 7:0, 5:1, 1:0, 8:1, 6:0, 4:1, 6:0, 4:1, 5:0, 9:1, 14:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 13:1, 6:0, 4:1, 7:0, 4:1, 4:0, 4:1, 2:0, 7:1, 8:0, 9:1, 7:0, 5:1, 1:0, 8:1, 5:0, 5:1, 6:0, 4:1, 7:0, 9:1, 12:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 12:1, 7:0, 4:1, 7:0, 4:1, 4:0, 4:1, 2:0, 6:1, 10:0, 8:1, 7:0, 5:1, 1:0, 7:1, 6:0, 4:1, 8:0, 4:1, 6:0, 9:1, 12:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 11:1, 8:0, 4:1, 6:0, 5:1, 4:0, 4:1, 2:0, 5:1, 10:0, 9:1, 7:0, 5:1, 1:0, 8:1, 5:0, 16:1, 7:0, 9:1, 11:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 4:1, 15:0, 4:1, 6:0, 5:1, 4:0, 4:1, 2:0, 4:1, 9:0, 6:1, 12:0, 5:1, 5:0, 5:1, 4:0, 16:1, 12:0, 6:1, 9:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 14:0, 4:1, 6:0, 5:1, 4:0, 4:1, 3:0, 4:1, 8:0, 5:1, 13:0, 5:1, 5:0, 6:1, 3:0, 16:1, 13:0, 5:1, 9:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 14:0, 4:1, 5:0, 6:1, 4:0, 4:1, 4:0, 4:1, 7:0, 4:1, 14:0, 5:1, 7:0, 4:1, 3:0, 16:1, 14:0, 4:1, 9:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 14:0, 4:1, 4:0, 7:1, 4:0, 4:1, 4:0, 4:1, 7:0, 4:1, 14:0, 5:1, 7:0, 4:1, 3:0, 4:1, 8:0, 4:1, 14:0, 4:1, 9:0, 5:1, 9:0, 3:1, 83:0"
    Data.s "19:0, 5:1, 14:0, 4:1, 4:0, 7:1, 4:0, 4:1, 4:0, 5:1, 6:0, 4:1, 7:0, 2:1, 5:0, 5:1, 7:0, 4:1, 3:0, 5:1, 7:0, 4:1, 5:0, 1:1, 8:0, 4:1, 9:0, 5:1, 9:0, 3:1, 8:0, 2:1, 73:0"
    Data.s "19:0, 5:1, 14:0, 5:1, 3:0, 7:1, 4:0, 4:1, 5:0, 4:1, 6:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 5:1, 3:0, 5:1, 7:0, 4:1, 3:0, 5:1, 6:0, 4:1, 9:0, 5:1, 9:0, 4:1, 6:0, 5:1, 12:0, 1:1, 11:0, 1:1, 11:0, 1:1, 34:0"
    Data.s "19:0, 5:1, 14:0, 5:1, 2:0, 8:1, 4:0, 4:1, 5:0, 4:1, 6:0, 5:1, 5:0, 5:1, 3:0, 5:1, 5:0, 6:1, 3:0, 5:1, 7:0, 4:1, 3:0, 5:1, 5:0, 5:1, 9:0, 5:1, 9:0, 5:1, 5:0, 5:1, 11:0, 3:1, 9:0, 3:1, 9:0, 3:1, 33:0"
    Data.s "19:0, 5:1, 15:0, 14:1, 4:0, 4:1, 6:0, 4:1, 6:0, 13:1, 4:0, 15:1, 4:0, 5:1, 7:0, 4:1, 4:0, 13:1, 8:0, 9:1, 8:0, 13:1, 11:0, 5:1, 7:0, 5:1, 7:0, 5:1, 32:0"
    Data.s "19:0, 5:1, 16:0, 8:1, 1:0, 4:1, 4:0, 4:1, 6:0, 5:1, 6:0, 11:1, 5:0, 14:1, 5:0, 5:1, 7:0, 4:1, 5:0, 11:1, 9:0, 9:1, 9:0, 11:1, 11:0, 7:1, 5:0, 7:1, 5:0, 7:1, 31:0"
    Data.s "19:0, 5:1, 17:0, 7:1, 1:0, 4:1, 4:0, 4:1, 7:0, 4:1, 7:0, 9:1, 6:0, 13:1, 6:0, 5:1, 7:0, 4:1, 6:0, 9:1, 10:0, 9:1, 10:0, 9:1, 13:0, 5:1, 7:0, 5:1, 7:0, 5:1, 32:0"
    Data.s "19:0, 5:1, 18:0, 5:1, 2:0, 4:1, 4:0, 4:1, 7:0, 4:1, 8:0, 7:1, 7:0, 12:1, 7:0, 5:1, 7:0, 4:1, 7:0, 7:1, 11:0, 9:1, 11:0, 7:1, 15:0, 3:1, 9:0, 3:1, 9:0, 3:1, 33:0"
    Data.s "20:0, 3:1, 20:0, 4:1, 3:0, 3:1, 4:0, 4:1, 8:0, 1:1, 10:0, 6:1, 9:0, 10:1, 8:0, 4:1, 8:0, 3:1, 9:0, 6:1, 11:0, 9:1, 11:0, 6:1, 17:0, 1:1, 11:0, 1:1, 11:0, 1:1, 34:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "11:0, 15:1, 9:0, 6:1, 12:0, 7:1, 8:0, 4:1, 33:0, 15:1, 4:0, 4:1, 7:0, 4:1, 8:0, 6:1, 103:0"
    Data.s "11:0, 15:1, 8:0, 8:1, 11:0, 8:1, 6:0, 5:1, 33:0, 15:1, 4:0, 4:1, 7:0, 4:1, 7:0, 8:1, 102:0"
    Data.s "11:0, 15:1, 7:0, 10:1, 8:0, 11:1, 5:0, 5:1, 33:0, 15:1, 4:0, 4:1, 7:0, 4:1, 6:0, 11:1, 100:0"
    Data.s "11:0, 15:1, 6:0, 12:1, 7:0, 11:1, 5:0, 5:1, 33:0, 15:1, 4:0, 4:1, 7:0, 4:1, 5:0, 12:1, 100:0"
    Data.s "11:0, 4:1, 16:0, 5:1, 3:0, 6:1, 4:0, 6:1, 3:0, 6:1, 3:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 6:1, 3:0, 6:1, 98:0"
    Data.s "11:0, 4:1, 15:0, 5:1, 5:0, 5:1, 4:0, 5:1, 5:0, 5:1, 3:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 5:0, 5:1, 98:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 7:0, 3:1, 5:0, 4:1, 7:0, 3:1, 4:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 7:0, 3:1, 99:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 8:0, 2:1, 5:0, 4:1, 8:0, 1:1, 5:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 8:0, 1:1, 100:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 15:0, 4:1, 14:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 109:0"
    Data.s "11:0, 4:1, 15:0, 5:1, 14:0, 5:1, 13:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 108:0"
    Data.s "11:0, 4:1, 16:0, 5:1, 13:0, 6:1, 12:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 6:1, 107:0"
    Data.s "11:0, 13:1, 8:0, 10:1, 8:0, 10:1, 7:0, 5:1, 39:0, 4:1, 9:0, 15:1, 5:0, 10:1, 102:0"
    Data.s "11:0, 13:1, 8:0, 10:1, 9:0, 9:1, 7:0, 5:1, 39:0, 4:1, 9:0, 15:1, 6:0, 9:1, 102:0"
    Data.s "11:0, 13:1, 9:0, 9:1, 10:0, 8:1, 7:0, 5:1, 39:0, 4:1, 9:0, 15:1, 7:0, 8:1, 102:0"
    Data.s "11:0, 13:1, 8:0, 10:1, 9:0, 9:1, 7:0, 5:1, 39:0, 4:1, 9:0, 15:1, 6:0, 9:1, 102:0"
    Data.s "11:0, 4:1, 1:0, 7:1, 8:0, 5:1, 1:0, 4:1, 9:0, 10:1, 7:0, 5:1, 39:0, 4:1, 9:0, 4:1, 1:0, 10:1, 5:0, 5:1, 1:0, 1:1, 1:0, 2:1, 102:0"
    Data.s "11:0, 4:1, 15:0, 5:1, 14:0, 5:1, 13:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 108:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 15:0, 4:1, 14:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 109:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 15:0, 4:1, 14:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 109:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 8:0, 2:1, 5:0, 4:1, 8:0, 2:1, 4:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 8:0, 1:1, 100:0"
    Data.s "11:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 7:0, 4:1, 3:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 7:0, 4:1, 98:0"
    Data.s "11:0, 4:1, 15:0, 6:1, 4:0, 5:1, 4:0, 5:1, 5:0, 5:1, 3:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 5:0, 5:1, 98:0"
    Data.s "11:0, 4:1, 16:0, 5:1, 3:0, 5:1, 6:0, 5:1, 3:0, 5:1, 4:0, 5:1, 39:0, 4:1, 9:0, 4:1, 7:0, 4:1, 5:0, 5:1, 3:0, 5:1, 99:0"
    Data.s "11:0, 4:1, 17:0, 11:1, 8:0, 11:1, 5:0, 16:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 6:0, 11:1, 100:0"
    Data.s "11:0, 4:1, 18:0, 10:1, 9:0, 9:1, 6:0, 16:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 7:0, 9:1, 101:0"
    Data.s "11:0, 4:1, 19:0, 7:1, 12:0, 7:1, 7:0, 16:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 8:0, 7:1, 102:0"
    Data.s "12:0, 3:1, 20:0, 5:1, 14:0, 5:1, 9:0, 15:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 9:0, 5:1, 103:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "44:0, 4:1, 1:0, 6:1, 8:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 6:1, 12:0, 6:1, 27:0, 4:1, 1:0, 6:1, 12:0, 7:1, 8:0, 4:1, 1:0, 4:1, 2:0, 4:1, 8:0, 6:1, 8:0, 4:1, 2:0, 5:1, 32:0"
    Data.s "44:0, 12:1, 7:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 6:1, 11:0, 8:1, 26:0, 11:1, 12:0, 7:1, 8:0, 4:1, 1:0, 4:1, 2:0, 4:1, 7:0, 8:1, 7:0, 4:1, 2:0, 6:1, 31:0"
    Data.s "44:0, 13:1, 6:0, 4:1, 7:0, 4:1, 4:0, 12:1, 9:0, 10:1, 25:0, 13:1, 8:0, 10:1, 7:0, 4:1, 1:0, 4:1, 2:0, 4:1, 6:0, 10:1, 6:0, 4:1, 1:0, 8:1, 30:0"
    Data.s "44:0, 14:1, 5:0, 4:1, 7:0, 4:1, 4:0, 13:1, 7:0, 12:1, 24:0, 13:1, 8:0, 11:1, 6:0, 4:1, 1:0, 4:1, 2:0, 4:1, 5:0, 12:1, 5:0, 14:1, 29:0"
    Data.s "44:0, 7:1, 2:0, 6:1, 4:0, 4:1, 7:0, 4:1, 4:0, 7:1, 2:0, 5:1, 5:0, 5:1, 4:0, 5:1, 23:0, 7:1, 2:0, 6:1, 5:0, 5:1, 3:0, 5:1, 5:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 5:1, 4:0, 5:1, 4:0, 8:1, 2:0, 5:1, 28:0"
    Data.s "44:0, 6:1, 4:0, 6:1, 3:0, 4:1, 7:0, 4:1, 4:0, 7:1, 3:0, 5:1, 4:0, 5:1, 5:0, 4:1, 23:0, 6:1, 4:0, 6:1, 3:0, 5:1, 5:0, 5:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 4:1, 6:0, 4:1, 4:0, 8:1, 3:0, 4:1, 28:0"
    Data.s "44:0, 6:1, 5:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 7:1, 4:0, 4:1, 4:0, 4:1, 7:0, 3:1, 23:0, 6:1, 5:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 4:1, 7:0, 3:1, 4:0, 7:1, 4:0, 4:1, 28:0"
    Data.s "44:0, 6:1, 5:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 4:1, 4:0, 4:1, 8:0, 1:1, 24:0, 6:1, 5:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 3:1, 9:0, 1:1, 5:0, 6:1, 5:0, 4:1, 28:0"
    Data.s "44:0, 5:1, 6:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 4:1, 4:0, 4:1, 33:0, 5:1, 6:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 3:1, 15:0, 6:1, 5:0, 4:1, 28:0"
    Data.s "44:0, 4:1, 7:0, 5:1, 3:0, 4:1, 7:0, 4:1, 4:0, 5:1, 5:0, 5:1, 4:0, 4:1, 33:0, 4:1, 7:0, 5:1, 2:0, 5:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 4:1, 14:0, 6:1, 5:0, 4:1, 28:0"
    Data.s "44:0, 4:1, 6:0, 6:1, 3:0, 4:1, 7:0, 4:1, 4:0, 4:1, 6:0, 5:1, 4:0, 5:1, 32:0, 4:1, 6:0, 5:1, 4:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 5:1, 13:0, 5:1, 5:0, 5:1, 28:0"
    Data.s "44:0, 4:1, 5:0, 5:1, 5:0, 4:1, 7:0, 4:1, 4:0, 4:1, 5:0, 5:1, 6:0, 5:1, 31:0, 4:1, 5:0, 5:1, 5:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 5:0, 5:1, 12:0, 4:1, 5:0, 5:1, 29:0"
    Data.s "44:0, 13:1, 6:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 8:1, 8:0, 9:1, 26:0, 13:1, 6:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 6:0, 9:1, 7:0, 4:1, 2:0, 7:1, 30:0"
    Data.s "44:0, 12:1, 7:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 7:1, 10:0, 8:1, 26:0, 12:1, 7:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 6:0, 9:1, 7:0, 4:1, 2:0, 6:1, 31:0"
    Data.s "44:0, 11:1, 8:0, 4:1, 6:0, 5:1, 4:0, 4:1, 2:0, 5:1, 9:0, 10:1, 26:0, 11:1, 8:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 5:0, 10:1, 7:0, 4:1, 2:0, 5:1, 32:0"
    Data.s "44:0, 10:1, 9:0, 4:1, 6:0, 5:1, 4:0, 4:1, 2:0, 4:1, 9:0, 11:1, 26:0, 10:1, 9:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 11:1, 7:0, 4:1, 2:0, 5:1, 32:0"
    Data.s "44:0, 4:1, 15:0, 4:1, 5:0, 6:1, 4:0, 4:1, 3:0, 4:1, 8:0, 5:1, 32:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 5:1, 13:0, 4:1, 3:0, 4:1, 32:0"
    Data.s "44:0, 4:1, 15:0, 4:1, 5:0, 6:1, 4:0, 4:1, 3:0, 4:1, 8:0, 4:1, 33:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 4:1, 14:0, 4:1, 4:0, 4:1, 31:0"
    Data.s "44:0, 4:1, 15:0, 4:1, 4:0, 7:1, 4:0, 4:1, 3:0, 5:1, 7:0, 4:1, 33:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 4:0, 3:1, 15:0, 4:1, 4:0, 4:1, 31:0"
    Data.s "44:0, 4:1, 15:0, 4:1, 4:0, 7:1, 4:0, 4:1, 4:0, 4:1, 7:0, 4:1, 7:0, 2:1, 24:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 1:0, 4:1, 5:0, 3:1, 8:0, 2:1, 5:0, 4:1, 4:0, 5:1, 30:0"
    Data.s "44:0, 4:1, 15:0, 4:1, 3:0, 8:1, 4:0, 4:1, 5:0, 4:1, 6:0, 4:1, 6:0, 4:1, 23:0, 4:1, 15:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 1:0, 4:1, 5:0, 4:1, 6:0, 4:1, 4:0, 4:1, 5:0, 4:1, 30:0"
    Data.s "44:0, 4:1, 15:0, 5:1, 2:0, 8:1, 4:0, 4:1, 5:0, 4:1, 6:0, 5:1, 4:0, 5:1, 23:0, 4:1, 15:0, 5:1, 5:0, 5:1, 4:0, 4:1, 1:0, 9:1, 5:0, 5:1, 4:0, 5:1, 4:0, 4:1, 6:0, 4:1, 13:0, 3:1, 13:0"
    Data.s "44:0, 4:1, 16:0, 5:1, 1:0, 8:1, 4:0, 4:1, 6:0, 4:1, 5:0, 6:1, 2:0, 6:1, 23:0, 4:1, 16:0, 5:1, 3:0, 5:1, 5:0, 13:1, 6:0, 6:1, 2:0, 6:1, 4:0, 4:1, 6:0, 4:1, 12:0, 5:1, 12:0"
    Data.s "44:0, 4:1, 17:0, 8:1, 1:0, 4:1, 4:0, 4:1, 6:0, 4:1, 7:0, 11:1, 24:0, 4:1, 17:0, 11:1, 7:0, 11:1, 8:0, 12:1, 5:0, 4:1, 7:0, 4:1, 10:0, 7:1, 11:0"
    Data.s "44:0, 4:1, 18:0, 6:1, 2:0, 4:1, 4:0, 4:1, 7:0, 4:1, 7:0, 9:1, 25:0, 4:1, 18:0, 9:1, 9:0, 10:1, 9:0, 10:1, 6:0, 4:1, 7:0, 4:1, 10:0, 7:1, 11:0"
    Data.s "44:0, 4:1, 19:0, 5:1, 2:0, 4:1, 4:0, 4:1, 7:0, 4:1, 7:0, 8:1, 26:0, 4:1, 19:0, 7:1, 11:0, 3:1, 1:0, 4:1, 11:0, 8:1, 7:0, 4:1, 8:0, 3:1, 12:0, 3:1, 13:0"
    Data.s "44:0, 4:1, 21:0, 2:1, 4:0, 3:1, 4:0, 3:1, 21:0, 4:1, 28:0, 4:1, 20:0, 5:1, 13:0, 1:1, 4:0, 1:1, 14:0, 4:1, 10:0, 3:1, 24:0, 1:1, 14:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "70:0, 4:1, 1:0, 6:1, 13:0, 6:1, 8:0, 4:1, 2:0, 5:1, 11:0, 9:1, 11:0, 6:1, 8:0, 4:1, 2:0, 5:1, 20:0, 5:1, 56:0"
    Data.s "70:0, 4:1, 1:0, 7:1, 11:0, 8:1, 7:0, 4:1, 1:0, 7:1, 10:0, 9:1, 10:0, 8:1, 7:0, 4:1, 2:0, 6:1, 19:0, 5:1, 56:0"
    Data.s "70:0, 13:1, 9:0, 10:1, 6:0, 4:1, 1:0, 7:1, 10:0, 9:1, 10:0, 9:1, 6:0, 4:1, 1:0, 8:1, 18:0, 5:1, 56:0"
    Data.s "70:0, 14:1, 7:0, 12:1, 5:0, 14:1, 8:0, 9:1, 8:0, 12:1, 5:0, 4:1, 1:0, 9:1, 17:0, 5:1, 56:0"
    Data.s "70:0, 7:1, 3:0, 5:1, 5:0, 5:1, 3:0, 6:1, 4:0, 8:1, 1:0, 5:1, 10:0, 5:1, 9:0, 6:1, 3:0, 5:1, 4:0, 8:1, 1:0, 6:1, 16:0, 5:1, 56:0"
    Data.s "70:0, 7:1, 4:0, 5:1, 3:0, 5:1, 5:0, 5:1, 4:0, 7:1, 3:0, 5:1, 9:0, 5:1, 9:0, 5:1, 5:0, 5:1, 3:0, 8:1, 3:0, 5:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 7:1, 5:0, 4:1, 3:0, 4:1, 7:0, 4:1, 4:0, 7:1, 4:0, 4:1, 9:0, 5:1, 9:0, 4:1, 7:0, 4:1, 3:0, 7:1, 5:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 6:1, 6:0, 4:1, 3:0, 5:1, 7:0, 2:1, 5:0, 6:1, 5:0, 4:1, 9:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 7:1, 5:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 5:1, 7:0, 4:1, 3:0, 4:1, 15:0, 6:1, 5:0, 4:1, 9:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 6:1, 6:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 5:1, 6:0, 5:1, 3:0, 5:1, 14:0, 5:1, 6:0, 4:1, 9:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 6:1, 6:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 4:1, 6:0, 6:1, 3:0, 6:1, 13:0, 5:1, 5:0, 5:1, 9:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 5:1, 7:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 4:1, 5:0, 6:1, 5:0, 6:1, 12:0, 5:1, 4:0, 5:1, 10:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 5:1, 7:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 14:1, 7:0, 10:1, 7:0, 4:1, 1:0, 8:1, 11:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 13:1, 9:0, 9:1, 7:0, 4:1, 1:0, 7:1, 12:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 15:0, 5:1, 56:0"
    Data.s "70:0, 12:1, 9:0, 10:1, 7:0, 4:1, 2:0, 5:1, 13:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 7:0, 5:1, 15:0, 4:1, 57:0"
    Data.s "70:0, 4:1, 16:0, 6:1, 12:0, 4:1, 2:0, 4:1, 14:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 15:0, 4:1, 57:0"
    Data.s "70:0, 4:1, 15:0, 6:1, 13:0, 4:1, 3:0, 4:1, 13:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 16:0, 3:1, 57:0"
    Data.s "70:0, 4:1, 15:0, 4:1, 15:0, 4:1, 3:0, 5:1, 12:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 16:0, 3:1, 57:0"
    Data.s "70:0, 4:1, 15:0, 5:1, 14:0, 4:1, 4:0, 4:1, 12:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 8:0, 4:1, 76:0"
    Data.s "70:0, 4:1, 15:0, 5:1, 7:0, 2:1, 5:0, 4:1, 4:0, 4:1, 12:0, 5:1, 9:0, 3:1, 8:0, 4:1, 3:0, 4:1, 7:0, 5:1, 76:0"
    Data.s "70:0, 4:1, 15:0, 5:1, 6:0, 4:1, 4:0, 4:1, 5:0, 4:1, 11:0, 5:1, 9:0, 4:1, 6:0, 5:1, 3:0, 4:1, 7:0, 5:1, 17:0, 1:1, 58:0"
    Data.s "70:0, 4:1, 15:0, 5:1, 5:0, 5:1, 4:0, 4:1, 6:0, 4:1, 10:0, 5:1, 9:0, 5:1, 5:0, 5:1, 3:0, 4:1, 6:0, 6:1, 16:0, 3:1, 57:0"
    Data.s "70:0, 4:1, 16:0, 13:1, 5:0, 4:1, 6:0, 4:1, 8:0, 8:1, 9:0, 13:1, 4:0, 4:1, 1:0, 10:1, 16:0, 5:1, 56:0"
    Data.s "70:0, 4:1, 17:0, 12:1, 5:0, 4:1, 6:0, 4:1, 8:0, 9:1, 8:0, 12:1, 5:0, 14:1, 16:0, 7:1, 55:0"
    Data.s "70:0, 4:1, 18:0, 9:1, 7:0, 4:1, 7:0, 4:1, 7:0, 9:1, 10:0, 9:1, 6:0, 13:1, 18:0, 5:1, 56:0"
    Data.s "70:0, 4:1, 19:0, 8:1, 7:0, 4:1, 8:0, 3:1, 7:0, 9:1, 10:0, 8:1, 7:0, 12:1, 20:0, 3:1, 57:0"
    Data.s "71:0, 3:1, 20:0, 6:1, 8:0, 4:1, 8:0, 2:1, 8:0, 9:1, 11:0, 6:1, 8:0, 11:1, 22:0, 2:1, 57:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "15:0, 226:1, 15:0"
    Data.s "15:0, 226:1, 15:0"
    Data.s "15:0, 226:1, 15:0"
    Data.s "15:0, 226:1, 15:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    
    BG_Animation_02:
    
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 8:0, 7:1, 32:0, 4:1, 10:0, 4:1, 1:0, 5:1, 12:0, 7:1, 27:0, 4:1, 6:0, 5:1, 8:0, 6:1, 8:0, 15:1, 38:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 7:0, 9:1, 31:0, 4:1, 9:0, 5:1, 1:0, 6:1, 10:0, 9:1, 26:0, 4:1, 6:0, 5:1, 7:0, 8:1, 7:0, 15:1, 38:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 6:0, 11:1, 29:0, 6:1, 8:0, 13:1, 8:0, 11:1, 25:0, 5:1, 6:0, 4:1, 6:0, 10:1, 6:0, 15:1, 38:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 5:0, 13:1, 28:0, 6:1, 8:0, 14:1, 6:0, 13:1, 24:0, 5:1, 5:0, 5:1, 5:0, 12:1, 5:0, 15:1, 38:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 6:1, 3:0, 6:1, 26:0, 8:1, 8:0, 7:1, 2:0, 5:1, 4:0, 6:1, 3:0, 6:1, 23:0, 5:1, 6:0, 4:1, 4:0, 5:1, 4:0, 6:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 5:1, 5:0, 5:1, 26:0, 9:1, 6:0, 8:1, 3:0, 5:1, 3:0, 5:1, 5:0, 5:1, 23:0, 6:1, 4:0, 5:1, 3:0, 5:1, 6:0, 5:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 7:0, 4:1, 26:0, 4:1, 1:0, 4:1, 6:0, 7:1, 4:0, 5:1, 3:0, 4:1, 7:0, 4:1, 23:0, 6:1, 4:0, 5:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 36:0, 4:1, 2:0, 5:1, 5:0, 6:1, 5:0, 5:1, 3:0, 4:1, 34:0, 7:1, 3:0, 5:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 36:0, 4:1, 2:0, 5:1, 5:0, 6:1, 5:0, 5:1, 3:0, 4:1, 34:0, 7:1, 3:0, 5:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 5:1, 34:0, 4:1, 4:0, 4:1, 5:0, 5:1, 6:0, 5:1, 3:0, 5:1, 33:0, 8:1, 2:0, 5:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 6:1, 32:0, 5:1, 4:0, 5:1, 4:0, 5:1, 5:0, 6:1, 3:0, 6:1, 32:0, 9:1, 2:0, 4:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 5:0, 10:1, 27:0, 4:1, 6:0, 4:1, 4:0, 5:1, 1:0, 8:1, 6:0, 11:1, 26:0, 4:1, 1:0, 4:1, 1:0, 5:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 6:0, 10:1, 25:0, 5:1, 7:0, 4:1, 3:0, 5:1, 1:0, 7:1, 8:0, 10:1, 26:0, 4:1, 1:0, 10:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 7:0, 9:1, 25:0, 4:1, 8:0, 4:1, 3:0, 5:1, 1:0, 6:1, 10:0, 9:1, 26:0, 4:1, 1:0, 5:1, 1:0, 4:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 6:0, 9:1, 26:0, 16:1, 3:0, 5:1, 1:0, 5:1, 10:0, 10:1, 26:0, 4:1, 2:0, 4:1, 1:0, 4:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 6:1, 31:0, 16:1, 3:0, 5:1, 1:0, 5:1, 9:0, 5:1, 32:0, 4:1, 2:0, 9:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 5:1, 32:0, 16:1, 3:0, 5:1, 2:0, 4:1, 8:0, 6:1, 32:0, 4:1, 3:0, 8:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 5:1, 32:0, 16:1, 3:0, 5:1, 3:0, 4:1, 7:0, 4:1, 34:0, 4:1, 4:0, 7:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 33:0, 4:1, 8:0, 4:1, 3:0, 5:1, 3:0, 4:1, 7:0, 4:1, 34:0, 4:1, 4:0, 7:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 7:0, 3:1, 23:0, 4:1, 8:0, 4:1, 3:0, 5:1, 4:0, 4:1, 6:0, 4:1, 8:0, 2:1, 24:0, 4:1, 5:0, 6:1, 3:0, 5:1, 7:0, 4:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 4:1, 2:0, 8:1, 5:0, 5:1, 6:0, 4:1, 22:0, 4:1, 8:0, 4:1, 3:0, 5:1, 4:0, 5:1, 5:0, 5:1, 6:0, 4:1, 23:0, 4:1, 5:0, 6:1, 3:0, 5:1, 6:0, 5:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 14:1, 5:0, 5:1, 5:0, 5:1, 22:0, 4:1, 8:0, 4:1, 3:0, 5:1, 5:0, 4:1, 5:0, 6:1, 4:0, 5:1, 23:0, 4:1, 6:0, 5:1, 4:0, 5:1, 4:0, 6:1, 9:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 20:0, 14:1, 6:0, 5:1, 3:0, 5:1, 23:0, 4:1, 8:0, 4:1, 3:0, 5:1, 5:0, 5:1, 5:0, 6:1, 2:0, 5:1, 24:0, 4:1, 6:0, 5:1, 5:0, 5:1, 2:0, 5:1, 11:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 21:0, 12:1, 8:0, 11:1, 24:0, 4:1, 8:0, 4:1, 3:0, 5:1, 6:0, 4:1, 6:0, 11:1, 25:0, 4:1, 6:0, 5:1, 6:0, 10:1, 12:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 22:0, 11:1, 9:0, 9:1, 25:0, 4:1, 8:0, 4:1, 3:0, 5:1, 6:0, 5:1, 6:0, 9:1, 26:0, 4:1, 7:0, 4:1, 6:0, 9:1, 13:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 23:0, 4:1, 1:0, 4:1, 11:0, 7:1, 26:0, 4:1, 8:0, 4:1, 3:0, 5:1, 6:0, 4:1, 8:0, 7:1, 27:0, 4:1, 7:0, 4:1, 7:0, 8:1, 13:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 24:0, 2:1, 3:0, 3:1, 12:0, 5:1, 27:0, 4:1, 8:0, 4:1, 4:0, 3:1, 8:0, 2:1, 10:0, 6:1, 27:0, 4:1, 8:0, 3:1, 8:0, 6:1, 14:0, 4:1, 43:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 18:0, 4:1, 9:0, 4:1, 19:0, 7:1, 8:0, 3:1, 8:0, 4:1, 8:0, 6:1, 29:0, 10:1, 6:0, 4:1, 8:0, 4:1, 22:0, 16:1, 3:0, 4:1, 7:0, 4:1, 8:0, 7:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 18:0, 4:1, 9:0, 4:1, 18:0, 9:1, 7:0, 4:1, 7:0, 4:1, 7:0, 8:1, 28:0, 10:1, 6:0, 5:1, 7:0, 4:1, 22:0, 16:1, 3:0, 4:1, 7:0, 4:1, 7:0, 9:1, 11:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 17:0, 6:1, 8:0, 4:1, 17:0, 11:1, 6:0, 4:1, 7:0, 4:1, 6:0, 10:1, 27:0, 10:1, 6:0, 5:1, 7:0, 4:1, 22:0, 16:1, 3:0, 4:1, 7:0, 4:1, 6:0, 11:1, 10:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 17:0, 6:1, 8:0, 4:1, 16:0, 13:1, 5:0, 5:1, 6:0, 4:1, 5:0, 12:1, 26:0, 10:1, 6:0, 6:1, 6:0, 4:1, 22:0, 16:1, 3:0, 4:1, 7:0, 4:1, 5:0, 13:1, 9:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 16:0, 8:1, 7:0, 4:1, 15:0, 6:1, 3:0, 6:1, 4:0, 5:1, 6:0, 4:1, 4:0, 5:1, 4:0, 5:1, 29:0, 4:1, 8:0, 6:1, 6:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 6:1, 3:0, 6:1, 8:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 16:0, 8:1, 7:0, 4:1, 15:0, 5:1, 5:0, 5:1, 4:0, 6:1, 5:0, 4:1, 3:0, 5:1, 5:0, 5:1, 29:0, 4:1, 8:0, 7:1, 5:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 6:1, 5:0, 5:1, 8:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 15:0, 4:1, 1:0, 4:1, 7:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 6:1, 5:0, 4:1, 3:0, 4:1, 7:0, 4:1, 29:0, 4:1, 8:0, 8:1, 4:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 7:0, 3:1, 9:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 14:0, 5:1, 2:0, 4:1, 6:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 7:1, 4:0, 4:1, 3:0, 4:1, 8:0, 2:1, 30:0, 4:1, 8:0, 8:1, 4:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 7:0, 2:1, 10:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 14:0, 5:1, 2:0, 4:1, 6:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 7:1, 4:0, 4:1, 3:0, 4:1, 40:0, 4:1, 8:0, 9:1, 3:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 19:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 14:0, 4:1, 4:0, 4:1, 5:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 8:1, 3:0, 4:1, 3:0, 5:1, 39:0, 4:1, 8:0, 9:1, 3:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 6:1, 18:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 13:0, 5:1, 4:0, 5:1, 4:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 8:1, 3:0, 4:1, 3:0, 6:1, 38:0, 4:1, 8:0, 9:1, 3:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 6:1, 17:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 13:0, 4:1, 6:0, 4:1, 4:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 9:1, 2:0, 4:1, 5:0, 10:1, 32:0, 4:1, 8:0, 10:1, 2:0, 4:1, 28:0, 4:1, 9:0, 15:1, 5:0, 10:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 5:1, 6:0, 5:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 1:0, 4:1, 2:0, 4:1, 6:0, 9:1, 32:0, 4:1, 8:0, 5:1, 1:0, 4:1, 2:0, 4:1, 28:0, 4:1, 9:0, 15:1, 6:0, 9:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 2:0, 4:1, 1:0, 4:1, 6:0, 9:1, 32:0, 4:1, 8:0, 5:1, 1:0, 5:1, 1:0, 4:1, 28:0, 4:1, 9:0, 15:1, 7:0, 8:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 16:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 2:0, 4:1, 1:0, 4:1, 5:0, 10:1, 32:0, 4:1, 8:0, 5:1, 2:0, 4:1, 1:0, 4:1, 28:0, 4:1, 9:0, 15:1, 5:0, 10:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 16:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 2:0, 9:1, 4:0, 6:1, 37:0, 4:1, 8:0, 5:1, 3:0, 8:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 6:1, 17:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 16:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 3:0, 8:1, 3:0, 6:1, 38:0, 4:1, 8:0, 5:1, 3:0, 8:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 18:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 16:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 3:0, 8:1, 3:0, 4:1, 40:0, 4:1, 8:0, 5:1, 4:0, 7:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 19:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 4:0, 7:1, 3:0, 4:1, 40:0, 4:1, 8:0, 5:1, 4:0, 7:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 19:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 14:0, 5:1, 7:0, 4:1, 4:0, 4:1, 4:0, 7:1, 3:0, 4:1, 8:0, 2:1, 30:0, 4:1, 8:0, 5:1, 4:0, 7:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 7:0, 3:1, 9:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 14:0, 5:1, 6:0, 5:1, 4:0, 4:1, 5:0, 6:1, 3:0, 5:1, 6:0, 4:1, 29:0, 4:1, 8:0, 5:1, 5:0, 6:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 5:1, 8:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 15:0, 5:1, 5:0, 5:1, 4:0, 4:1, 5:0, 6:1, 3:0, 6:1, 4:0, 5:1, 29:0, 4:1, 8:0, 5:1, 5:0, 6:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 4:0, 5:1, 4:0, 6:1, 8:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 16:0, 5:1, 3:0, 5:1, 5:0, 4:1, 6:0, 5:1, 4:0, 6:1, 2:0, 6:1, 29:0, 4:1, 8:0, 5:1, 6:0, 5:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 5:0, 5:1, 2:0, 6:1, 9:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 15:1, 6:0, 11:1, 6:0, 4:1, 7:0, 4:1, 5:0, 12:1, 26:0, 10:1, 6:0, 5:1, 7:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 6:0, 11:1, 10:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 15:1, 7:0, 9:1, 7:0, 4:1, 7:0, 4:1, 7:0, 9:1, 27:0, 10:1, 6:0, 5:1, 7:0, 4:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 7:0, 9:1, 11:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 15:1, 8:0, 7:1, 8:0, 4:1, 7:0, 4:1, 7:0, 8:1, 28:0, 10:1, 6:0, 5:1, 8:0, 3:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 8:0, 7:1, 12:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 15:1, 9:0, 5:1, 9:0, 4:1, 8:0, 3:1, 8:0, 6:1, 29:0, 10:1, 6:0, 5:1, 8:0, 3:1, 28:0, 4:1, 9:0, 4:1, 7:0, 4:1, 9:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 7:0, 4:1, 7:0, 9:1, 7:0, 4:1, 6:0, 1:1, 11:0, 7:1, 8:0, 4:1, 1:0, 6:1, 12:0, 7:1, 12:0, 7:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 7:0, 4:1, 7:0, 9:1, 7:0, 4:1, 4:0, 4:1, 10:0, 8:1, 7:0, 4:1, 1:0, 7:1, 10:0, 9:1, 10:0, 9:1, 86:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 5:1, 6:0, 4:1, 7:0, 9:1, 7:0, 4:1, 4:0, 5:1, 8:0, 10:1, 6:0, 4:1, 1:0, 8:1, 8:0, 11:1, 8:0, 10:1, 86:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 5:1, 6:0, 4:1, 7:0, 9:1, 7:0, 4:1, 4:0, 7:1, 5:0, 12:1, 5:0, 14:1, 6:0, 13:1, 6:0, 12:1, 85:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 6:1, 5:0, 4:1, 9:0, 4:1, 10:0, 4:1, 6:0, 5:1, 4:0, 6:1, 2:0, 6:1, 4:0, 8:1, 1:0, 6:1, 4:0, 6:1, 3:0, 6:1, 4:0, 6:1, 3:0, 5:1, 84:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 6:1, 5:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 5:1, 3:0, 7:1, 3:0, 5:1, 4:0, 5:1, 5:0, 5:1, 3:0, 6:1, 5:0, 5:1, 83:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 7:1, 4:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 4:1, 8:0, 3:1, 4:0, 7:1, 4:0, 4:1, 4:0, 4:1, 7:0, 3:1, 4:0, 5:1, 7:0, 3:1, 84:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 7:1, 4:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 4:1, 9:0, 1:1, 5:0, 6:1, 5:0, 4:1, 4:0, 4:1, 8:0, 1:1, 5:0, 5:1, 8:0, 1:1, 85:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 8:1, 3:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 4:1, 15:0, 6:1, 5:0, 4:1, 4:0, 4:1, 14:0, 5:1, 94:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 8:1, 3:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 5:1, 14:0, 5:1, 6:0, 4:1, 4:0, 5:1, 13:0, 5:1, 94:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 8:1, 3:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 6:1, 13:0, 5:1, 5:0, 5:1, 4:0, 6:1, 13:0, 5:1, 93:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 1:0, 4:1, 2:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 5:0, 10:1, 7:0, 5:1, 1:0, 8:1, 6:0, 10:1, 9:0, 10:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 8:0, 4:1, 3:0, 4:1, 1:0, 5:1, 1:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 6:0, 9:1, 7:0, 13:1, 8:0, 9:1, 10:0, 9:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 7:0, 5:1, 3:0, 4:1, 2:0, 4:1, 1:0, 4:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 6:0, 9:1, 7:0, 4:1, 1:0, 7:1, 10:0, 9:1, 9:0, 9:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 7:0, 5:1, 3:0, 4:1, 2:0, 9:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 5:0, 10:1, 7:0, 4:1, 2:0, 5:1, 12:0, 9:1, 7:0, 10:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 6:0, 6:1, 3:0, 4:1, 3:0, 8:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 4:0, 10:1, 8:0, 4:1, 2:0, 5:1, 13:0, 3:1, 1:0, 5:1, 5:0, 6:1, 1:0, 4:1, 87:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 6:0, 6:1, 3:0, 4:1, 3:0, 8:1, 9:0, 4:1, 10:0, 4:1, 7:0, 4:1, 3:0, 6:1, 13:0, 4:1, 3:0, 4:1, 18:0, 5:1, 4:0, 5:1, 93:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 5:0, 7:1, 3:0, 4:1, 4:0, 7:1, 9:0, 4:1, 10:0, 4:1, 6:0, 5:1, 3:0, 5:1, 14:0, 4:1, 3:0, 5:1, 18:0, 5:1, 2:0, 5:1, 94:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 4:0, 8:1, 3:0, 4:1, 4:0, 7:1, 9:0, 4:1, 10:0, 4:1, 6:0, 4:1, 4:0, 4:1, 15:0, 4:1, 4:0, 4:1, 18:0, 5:1, 2:0, 5:1, 94:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 4:0, 8:1, 3:0, 4:1, 5:0, 6:1, 9:0, 4:1, 10:0, 4:1, 5:0, 5:1, 4:0, 4:1, 8:0, 2:1, 5:0, 4:1, 5:0, 4:1, 7:0, 2:1, 8:0, 5:1, 2:0, 5:1, 7:0, 2:1, 85:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 5:1, 2:0, 9:1, 3:0, 4:1, 5:0, 6:1, 9:0, 4:1, 10:0, 4:1, 5:0, 4:1, 5:0, 5:1, 6:0, 4:1, 4:0, 4:1, 5:0, 4:1, 6:0, 5:1, 6:0, 5:1, 2:0, 5:1, 6:0, 4:1, 31:0, 1:1, 17:0, 1:1, 17:0, 2:1, 15:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 6:1, 1:0, 4:1, 1:0, 4:1, 3:0, 4:1, 6:0, 5:1, 9:0, 4:1, 10:0, 5:1, 3:0, 4:1, 6:0, 6:1, 4:0, 6:1, 3:0, 4:1, 6:0, 4:1, 5:0, 6:1, 4:0, 5:1, 4:0, 5:1, 4:0, 6:1, 28:0, 4:1, 15:0, 3:1, 16:0, 3:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 13:0, 10:1, 1:0, 4:1, 3:0, 4:1, 6:0, 5:1, 7:0, 9:1, 8:0, 11:1, 7:0, 14:1, 4:0, 4:1, 6:0, 5:1, 5:0, 13:1, 6:0, 13:1, 28:0, 6:1, 13:0, 6:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 14:0, 9:1, 1:0, 4:1, 3:0, 4:1, 7:0, 4:1, 7:0, 9:1, 8:0, 10:1, 9:0, 12:1, 5:0, 4:1, 6:0, 5:1, 6:0, 11:1, 8:0, 11:1, 29:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 15:0, 7:1, 2:0, 4:1, 3:0, 4:1, 7:0, 4:1, 7:0, 9:1, 9:0, 9:1, 10:0, 10:1, 6:0, 4:1, 7:0, 4:1, 7:0, 9:1, 10:0, 9:1, 30:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 16:0, 5:1, 3:0, 4:1, 3:0, 4:1, 8:0, 3:1, 7:0, 9:1, 10:0, 8:1, 11:0, 8:1, 7:0, 4:1, 7:0, 4:1, 8:0, 7:1, 11:0, 8:1, 32:0, 4:1, 15:0, 3:1, 15:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 188:0, 2:1, 17:0, 1:1, 17:0, 2:1, 15:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 9:0, 3:1, 10:0, 4:1, 7:0, 3:1, 9:0, 6:1, 27:0, 4:1, 7:0, 4:1, 4:0, 4:1, 1:0, 6:1, 31:0, 6:1, 13:0, 6:1, 12:0, 7:1, 13:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 5:1, 8:0, 5:1, 7:0, 4:1, 7:0, 8:1, 26:0, 4:1, 7:0, 4:1, 4:0, 11:1, 31:0, 6:1, 13:0, 6:1, 12:0, 7:1, 13:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 8:0, 5:1, 8:0, 5:1, 6:0, 5:1, 6:0, 10:1, 25:0, 4:1, 7:0, 4:1, 4:0, 13:1, 29:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 7:0, 7:1, 7:0, 5:1, 6:0, 4:1, 6:0, 12:1, 24:0, 4:1, 7:0, 4:1, 4:0, 14:1, 28:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 7:0, 7:1, 7:0, 5:1, 6:0, 4:1, 5:0, 6:1, 3:0, 6:1, 22:0, 4:1, 7:0, 4:1, 4:0, 7:1, 2:0, 6:1, 27:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 6:0, 9:1, 6:0, 5:1, 5:0, 4:1, 6:0, 5:1, 5:0, 5:1, 22:0, 4:1, 7:0, 4:1, 4:0, 6:1, 4:0, 6:1, 26:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 6:0, 10:1, 5:0, 5:1, 5:0, 4:1, 6:0, 4:1, 7:0, 3:1, 23:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 5:1, 26:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 6:0, 4:1, 1:0, 5:1, 5:0, 5:1, 4:0, 4:1, 7:0, 4:1, 8:0, 1:1, 24:0, 4:1, 7:0, 4:1, 4:0, 6:1, 5:0, 5:1, 26:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 5:0, 5:1, 2:0, 4:1, 5:0, 5:1, 3:0, 5:1, 7:0, 4:1, 33:0, 4:1, 7:0, 4:1, 4:0, 5:1, 6:0, 5:1, 26:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 5:0, 4:1, 3:0, 5:1, 4:0, 5:1, 3:0, 4:1, 8:0, 4:1, 33:0, 4:1, 7:0, 4:1, 4:0, 4:1, 6:0, 6:1, 26:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 4:0, 4:1, 5:0, 4:1, 4:0, 5:1, 2:0, 5:1, 8:0, 5:1, 32:0, 4:1, 7:0, 4:1, 4:0, 4:1, 5:0, 6:1, 27:0, 6:1, 13:0, 6:1, 13:0, 5:1, 14:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 4:0, 4:1, 5:0, 5:1, 3:0, 5:1, 2:0, 4:1, 10:0, 5:1, 31:0, 4:1, 7:0, 4:1, 4:0, 4:1, 4:0, 6:1, 28:0, 5:1, 14:0, 6:1, 13:0, 5:1, 14:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 4:1, 7:0, 4:1, 3:0, 5:1, 1:0, 5:1, 11:0, 9:1, 26:0, 4:1, 7:0, 4:1, 4:0, 13:1, 29:0, 5:1, 14:0, 6:1, 13:0, 5:1, 14:0, 5:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 4:1, 7:0, 4:1, 3:0, 5:1, 1:0, 4:1, 12:0, 9:1, 26:0, 4:1, 7:0, 4:1, 4:0, 12:1, 30:0, 5:1, 15:0, 4:1, 14:0, 5:1, 14:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 15:1, 3:0, 5:1, 1:0, 5:1, 10:0, 10:1, 26:0, 4:1, 6:0, 5:1, 4:0, 11:1, 32:0, 4:1, 15:0, 4:1, 14:0, 5:1, 14:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 15:1, 3:0, 5:1, 2:0, 4:1, 10:0, 10:1, 26:0, 4:1, 6:0, 5:1, 4:0, 10:1, 33:0, 4:1, 15:0, 4:1, 15:0, 3:1, 15:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 15:1, 3:0, 5:1, 2:0, 5:1, 8:0, 5:1, 32:0, 4:1, 6:0, 5:1, 4:0, 4:1, 39:0, 4:1, 15:0, 4:1, 15:0, 3:1, 15:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 2:0, 4:1, 3:0, 15:1, 3:0, 5:1, 3:0, 4:1, 8:0, 4:1, 33:0, 4:1, 5:0, 6:1, 4:0, 4:1, 39:0, 4:1, 15:0, 4:1, 15:0, 3:1, 15:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 1:0, 5:1, 3:0, 4:1, 7:0, 4:1, 3:0, 5:1, 4:0, 4:1, 7:0, 4:1, 33:0, 4:1, 4:0, 7:1, 4:0, 4:1, 113:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 4:1, 1:0, 4:1, 4:0, 4:1, 7:0, 4:1, 3:0, 5:1, 4:0, 5:1, 6:0, 4:1, 7:0, 3:1, 23:0, 4:1, 4:0, 7:1, 4:0, 4:1, 113:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 4:1, 2:0, 9:1, 4:0, 4:1, 7:0, 4:1, 3:0, 5:1, 5:0, 4:1, 6:0, 4:1, 6:0, 5:1, 22:0, 4:1, 3:0, 8:1, 4:0, 4:1, 40:0, 1:1, 19:0, 1:1, 17:0, 1:1, 34:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 5:1, 1:0, 8:1, 5:0, 4:1, 7:0, 4:1, 3:0, 5:1, 5:0, 5:1, 5:0, 5:1, 4:0, 6:1, 22:0, 5:1, 2:0, 8:1, 4:0, 4:1, 39:0, 4:1, 15:0, 3:1, 16:0, 3:1, 16:0, 3:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 12:0, 14:1, 5:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 4:1, 6:0, 13:1, 24:0, 9:1, 1:0, 4:1, 4:0, 4:1, 38:0, 6:1, 13:0, 6:1, 13:0, 5:1, 13:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 13:0, 12:1, 6:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 4:1, 7:0, 11:1, 26:0, 8:1, 1:0, 4:1, 4:0, 4:1, 38:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 14:0, 11:1, 6:0, 4:1, 7:0, 4:1, 3:0, 5:1, 6:0, 5:1, 6:0, 10:1, 28:0, 7:1, 1:0, 4:1, 4:0, 4:1, 38:0, 6:1, 13:0, 6:1, 12:0, 7:1, 12:0, 6:1, 13:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 15:0, 4:1, 1:0, 4:1, 7:0, 4:1, 7:0, 4:1, 3:0, 5:1, 7:0, 4:1, 7:0, 8:1, 30:0, 5:1, 2:0, 4:1, 4:0, 4:1, 39:0, 4:1, 15:0, 4:1, 15:0, 4:1, 14:0, 4:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 16:0, 2:1, 3:0, 3:1, 7:0, 4:1, 7:0, 4:1, 4:0, 3:1, 8:0, 3:1, 9:0, 6:1, 32:0, 3:1, 3:0, 4:1, 4:0, 4:1, 40:0, 2:1, 17:0, 2:1, 17:0, 2:1, 16:0, 3:1, 14:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 242:0, 4:1, 3:0"
    Data.s "3:0, 4:1, 1:0, 240:1, 1:0, 4:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "3:0, 250:1, 3:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    
    BG_Animation_03:
    
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "27:0, 13:1, 3:0, 3:1, 5:0, 4:1, 6:0, 5:1, 21:0, 13:1, 5:0, 8:1, 5:0, 3:1, 6:0, 3:1, 7:0, 3:1, 8:0, 3:1, 6:0, 3:1, 6:0, 5:1, 9:0, 8:1, 9:0, 3:1, 8:0, 3:1, 45:0"
    Data.s "27:0, 13:1, 3:0, 3:1, 5:0, 4:1, 5:0, 7:1, 20:0, 13:1, 5:0, 8:1, 5:0, 3:1, 6:0, 3:1, 7:0, 4:1, 6:0, 4:1, 5:0, 4:1, 5:0, 7:1, 8:0, 8:1, 9:0, 4:1, 7:0, 3:1, 45:0"
    Data.s "27:0, 13:1, 3:0, 3:1, 5:0, 4:1, 4:0, 9:1, 19:0, 13:1, 5:0, 8:1, 5:0, 4:1, 5:0, 3:1, 7:0, 4:1, 6:0, 4:1, 5:0, 4:1, 4:0, 9:1, 7:0, 8:1, 9:0, 4:1, 7:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 5:1, 2:0, 4:1, 18:0, 4:1, 16:0, 4:1, 7:0, 4:1, 5:0, 3:1, 6:0, 6:1, 5:0, 5:1, 4:0, 4:1, 3:0, 5:1, 2:0, 5:1, 7:0, 3:1, 11:0, 6:1, 6:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 4:1, 3:0, 5:1, 17:0, 4:1, 16:0, 3:1, 8:0, 4:1, 5:0, 3:1, 5:0, 7:1, 5:0, 6:1, 3:0, 4:1, 3:0, 4:1, 4:0, 4:1, 7:0, 3:1, 10:0, 7:1, 6:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 6:0, 2:1, 18:0, 4:1, 16:0, 4:1, 7:0, 5:1, 4:0, 3:1, 5:0, 8:1, 4:0, 6:1, 3:0, 4:1, 3:0, 3:1, 6:0, 2:1, 8:0, 3:1, 10:0, 8:1, 5:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 26:0, 4:1, 16:0, 4:1, 7:0, 6:1, 3:0, 3:1, 5:0, 3:1, 2:0, 3:1, 4:0, 7:1, 2:0, 4:1, 3:0, 3:1, 16:0, 3:1, 10:0, 3:1, 2:0, 3:1, 5:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 26:0, 4:1, 16:0, 4:1, 7:0, 6:1, 3:0, 3:1, 4:0, 3:1, 3:0, 4:1, 3:0, 7:1, 2:0, 4:1, 3:0, 3:1, 16:0, 3:1, 9:0, 3:1, 3:0, 4:1, 4:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 4:1, 25:0, 4:1, 16:0, 4:1, 7:0, 7:1, 2:0, 3:1, 3:0, 4:1, 3:0, 4:1, 3:0, 8:1, 1:0, 4:1, 3:0, 3:1, 16:0, 3:1, 9:0, 3:1, 4:0, 3:1, 4:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 12:1, 3:0, 9:1, 20:0, 11:1, 9:0, 4:1, 7:0, 3:1, 1:0, 3:1, 2:0, 3:1, 3:0, 4:1, 4:0, 3:1, 3:0, 8:1, 1:0, 4:1, 3:0, 3:1, 16:0, 3:1, 8:0, 4:1, 4:0, 4:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 12:1, 5:0, 7:1, 20:0, 11:1, 9:0, 4:1, 7:0, 3:1, 1:0, 3:1, 2:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 1:0, 8:1, 3:0, 3:1, 16:0, 3:1, 7:0, 4:1, 6:0, 3:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 12:1, 4:0, 8:1, 20:0, 11:1, 9:0, 4:1, 7:0, 3:1, 2:0, 3:1, 1:0, 3:1, 2:0, 4:1, 1:0, 4:1, 1:0, 3:1, 2:0, 4:1, 1:0, 8:1, 3:0, 3:1, 16:0, 3:1, 7:0, 4:1, 1:0, 4:1, 1:0, 3:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 5:1, 24:0, 4:1, 16:0, 4:1, 7:0, 3:1, 2:0, 3:1, 1:0, 3:1, 2:0, 13:1, 2:0, 4:1, 2:0, 7:1, 3:0, 3:1, 16:0, 3:1, 7:0, 13:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 4:1, 25:0, 4:1, 16:0, 4:1, 7:0, 3:1, 2:0, 7:1, 2:0, 13:1, 2:0, 4:1, 3:0, 6:1, 3:0, 3:1, 16:0, 3:1, 7:0, 13:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 26:0, 4:1, 16:0, 4:1, 7:0, 3:1, 3:0, 6:1, 2:0, 13:1, 2:0, 4:1, 3:0, 6:1, 3:0, 3:1, 16:0, 3:1, 7:0, 13:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 6:0, 2:1, 18:0, 4:1, 16:0, 4:1, 7:0, 3:1, 4:0, 5:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 3:0, 3:1, 6:0, 2:1, 8:0, 3:1, 7:0, 4:1, 6:0, 3:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 3:1, 5:0, 4:1, 17:0, 4:1, 16:0, 4:1, 7:0, 3:1, 4:0, 5:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 4:0, 5:1, 3:0, 3:1, 5:0, 4:1, 7:0, 3:1, 7:0, 4:1, 6:0, 3:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 4:1, 3:0, 5:1, 17:0, 4:1, 16:0, 3:1, 8:0, 3:1, 4:0, 5:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 3:0, 4:1, 3:0, 5:1, 7:0, 3:1, 7:0, 4:1, 6:0, 3:1, 3:0, 3:1, 45:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 3:0, 11:1, 18:0, 4:1, 14:0, 8:1, 5:0, 3:1, 5:0, 4:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 4:0, 10:1, 6:0, 8:1, 4:0, 4:1, 6:0, 3:1, 3:0, 12:1, 36:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 5:0, 8:1, 19:0, 4:1, 14:0, 8:1, 5:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 5:0, 8:1, 7:0, 8:1, 4:0, 4:1, 6:0, 3:1, 3:0, 12:1, 36:0"
    Data.s "32:0, 4:1, 7:0, 3:1, 5:0, 4:1, 5:0, 7:1, 20:0, 4:1, 14:0, 8:1, 5:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 6:0, 6:1, 8:0, 8:1, 4:0, 4:1, 6:0, 3:1, 3:0, 12:1, 36:0"
    Data.s "32:0, 3:1, 8:0, 2:1, 7:0, 3:1, 6:0, 5:1, 22:0, 3:1, 14:0, 7:1, 6:0, 3:1, 7:0, 2:1, 3:0, 3:1, 6:0, 3:1, 3:0, 3:1, 6:0, 3:1, 6:0, 5:1, 9:0, 7:1, 6:0, 3:1, 6:0, 3:1, 3:0, 12:1, 36:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "23:0, 5:1, 8:0, 2:1, 6:0, 1:1, 8:0, 5:1, 7:0, 12:1, 6:0, 5:1, 6:0, 4:1, 6:0, 3:1, 20:0, 7:1, 9:0, 5:1, 27:0, 2:1, 8:0, 3:1, 1:0, 4:1, 10:0, 5:1, 7:0, 3:1, 6:0, 3:1, 3:0, 12:1, 14:0"
    Data.s "22:0, 7:1, 5:0, 4:1, 5:0, 4:1, 5:0, 7:1, 6:0, 12:1, 5:0, 7:1, 5:0, 4:1, 5:0, 4:1, 20:0, 8:1, 7:0, 7:1, 25:0, 4:1, 7:0, 3:1, 1:0, 5:1, 8:0, 7:1, 5:0, 4:1, 6:0, 3:1, 3:0, 12:1, 14:0"
    Data.s "21:0, 9:1, 5:0, 3:1, 5:0, 3:1, 5:0, 9:1, 5:0, 12:1, 4:0, 9:1, 4:0, 4:1, 5:0, 4:1, 20:0, 8:1, 6:0, 9:1, 23:0, 5:1, 7:0, 10:1, 6:0, 9:1, 4:0, 4:1, 6:0, 3:1, 3:0, 12:1, 14:0"
    Data.s "20:0, 5:1, 2:0, 4:1, 5:0, 3:1, 3:0, 4:1, 4:0, 5:1, 2:0, 4:1, 8:0, 3:1, 8:0, 5:1, 2:0, 4:1, 3:0, 5:1, 4:0, 4:1, 22:0, 3:1, 8:0, 5:1, 2:0, 4:1, 22:0, 5:1, 7:0, 6:1, 1:0, 4:1, 4:0, 5:1, 2:0, 4:1, 3:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 5:1, 3:0, 4:1, 5:0, 3:1, 3:0, 3:1, 4:0, 5:1, 4:0, 4:1, 7:0, 3:1, 7:0, 5:1, 3:0, 5:1, 2:0, 6:1, 2:0, 5:1, 22:0, 3:1, 8:0, 4:1, 4:0, 4:1, 21:0, 6:1, 6:0, 6:1, 2:0, 4:1, 3:0, 4:1, 4:0, 4:1, 2:0, 5:1, 5:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 4:1, 6:0, 2:1, 5:0, 4:1, 1:0, 4:1, 4:0, 4:1, 5:0, 3:1, 8:0, 3:1, 7:0, 4:1, 6:0, 2:1, 3:0, 6:1, 1:0, 6:1, 22:0, 3:1, 7:0, 4:1, 6:0, 2:1, 21:0, 8:1, 5:0, 5:1, 4:0, 3:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 4:1, 14:0, 7:1, 5:0, 4:1, 16:0, 3:1, 7:0, 4:1, 11:0, 13:1, 22:0, 3:1, 7:0, 4:1, 28:0, 4:1, 1:0, 4:1, 5:0, 5:1, 4:0, 3:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 4:1, 14:0, 7:1, 5:0, 4:1, 16:0, 3:1, 7:0, 4:1, 11:0, 13:1, 22:0, 3:1, 7:0, 4:1, 28:0, 4:1, 2:0, 4:1, 4:0, 4:1, 4:0, 4:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 5:1, 14:0, 5:1, 7:0, 4:1, 15:0, 3:1, 7:0, 5:1, 10:0, 9:1, 1:0, 3:1, 22:0, 3:1, 8:0, 4:1, 27:0, 3:1, 4:0, 3:1, 4:0, 4:1, 3:0, 5:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "20:0, 8:1, 10:0, 5:1, 8:0, 7:1, 11:0, 3:1, 8:0, 9:1, 5:0, 4:1, 1:0, 8:1, 22:0, 3:1, 8:0, 8:1, 22:0, 3:1, 5:0, 4:1, 3:0, 3:1, 1:0, 7:1, 4:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "22:0, 7:1, 10:0, 4:1, 8:0, 8:1, 10:0, 3:1, 10:0, 7:1, 5:0, 4:1, 1:0, 8:1, 22:0, 3:1, 10:0, 7:1, 21:0, 3:1, 5:0, 4:1, 3:0, 3:1, 1:0, 6:1, 5:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "22:0, 8:1, 9:0, 4:1, 10:0, 7:1, 9:0, 3:1, 9:0, 8:1, 5:0, 4:1, 1:0, 3:1, 1:0, 4:1, 22:0, 3:1, 11:0, 7:1, 20:0, 12:1, 3:0, 3:1, 1:0, 6:1, 5:0, 3:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 18:0"
    Data.s "23:0, 8:1, 8:0, 4:1, 10:0, 8:1, 8:0, 3:1, 8:0, 9:1, 5:0, 4:1, 5:0, 4:1, 22:0, 3:1, 11:0, 8:1, 19:0, 12:1, 3:0, 3:1, 1:0, 7:1, 4:0, 3:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 18:0"
    Data.s "27:0, 5:1, 7:0, 4:1, 15:0, 4:1, 7:0, 3:1, 7:0, 5:1, 10:0, 4:1, 5:0, 4:1, 22:0, 3:1, 16:0, 4:1, 18:0, 12:1, 3:0, 3:1, 5:0, 4:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 4:0, 5:1, 7:0, 4:1, 18:0"
    Data.s "29:0, 3:1, 7:0, 4:1, 15:0, 4:1, 7:0, 3:1, 7:0, 4:1, 11:0, 4:1, 5:0, 4:1, 22:0, 3:1, 17:0, 3:1, 18:0, 12:1, 3:0, 3:1, 6:0, 3:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 18:0"
    Data.s "21:0, 1:1, 7:0, 3:1, 7:0, 4:1, 8:0, 1:1, 6:0, 4:1, 7:0, 3:1, 7:0, 4:1, 6:0, 2:1, 3:0, 4:1, 5:0, 4:1, 22:0, 3:1, 9:0, 1:1, 7:0, 3:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 6:0, 3:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 4:1, 5:0, 4:1, 7:0, 4:1, 7:0, 3:1, 5:0, 4:1, 7:0, 3:1, 7:0, 4:1, 5:0, 4:1, 2:0, 4:1, 5:0, 4:1, 22:0, 3:1, 8:0, 3:1, 5:0, 4:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 5:0, 4:1, 3:0, 3:1, 5:0, 4:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 18:0"
    Data.s "19:0, 5:1, 3:0, 5:1, 7:0, 4:1, 7:0, 4:1, 3:0, 5:1, 7:0, 3:1, 7:0, 5:1, 3:0, 5:1, 2:0, 4:1, 5:0, 4:1, 22:0, 3:1, 8:0, 4:1, 3:0, 5:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 5:0, 4:1, 3:0, 4:1, 3:0, 5:1, 3:0, 4:1, 1:0, 7:1, 7:0, 4:1, 18:0"
    Data.s "20:0, 11:1, 8:0, 4:1, 8:0, 10:1, 8:0, 3:1, 9:0, 10:1, 3:0, 4:1, 5:0, 4:1, 20:0, 8:1, 6:0, 10:1, 19:0, 3:1, 5:0, 4:1, 3:0, 11:1, 5:0, 10:1, 5:0, 7:1, 1:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "21:0, 9:1, 9:0, 4:1, 8:0, 9:1, 9:0, 3:1, 10:0, 8:1, 4:0, 4:1, 5:0, 4:1, 20:0, 8:1, 7:0, 8:1, 20:0, 3:1, 5:0, 4:1, 3:0, 10:1, 7:0, 8:1, 7:0, 6:1, 1:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "22:0, 7:1, 10:0, 4:1, 10:0, 6:1, 10:0, 3:1, 11:0, 6:1, 5:0, 4:1, 5:0, 4:1, 20:0, 8:1, 8:0, 6:1, 21:0, 3:1, 5:0, 4:1, 3:0, 9:1, 9:0, 6:1, 9:0, 4:1, 2:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "23:0, 5:1, 11:0, 3:1, 12:0, 4:1, 11:0, 3:1, 12:0, 4:1, 7:0, 3:1, 6:0, 3:1, 20:0, 7:1, 10:0, 4:1, 22:0, 3:1, 6:0, 3:1, 3:0, 8:1, 11:0, 4:1, 11:0, 3:1, 2:0, 3:1, 7:0, 4:1, 18:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "48:0, 12:1, 6:0, 5:1, 25:0, 5:1, 10:0, 5:1, 7:0, 3:1, 11:0, 4:1, 16:0, 3:1, 8:0, 8:1, 10:0, 5:1, 10:0, 5:1, 50:0"
    Data.s "47:0, 13:1, 5:0, 7:1, 23:0, 7:1, 8:0, 7:1, 6:0, 3:1, 11:0, 4:1, 16:0, 4:1, 7:0, 9:1, 8:0, 7:1, 8:0, 7:1, 49:0"
    Data.s "47:0, 13:1, 4:0, 9:1, 21:0, 9:1, 6:0, 9:1, 5:0, 3:1, 11:0, 4:1, 15:0, 5:1, 7:0, 10:1, 6:0, 9:1, 6:0, 9:1, 48:0"
    Data.s "48:0, 12:1, 3:0, 11:1, 19:0, 11:1, 4:0, 11:1, 4:0, 3:1, 11:0, 4:1, 15:0, 5:1, 7:0, 11:1, 4:0, 11:1, 4:0, 11:1, 47:0"
    Data.s "52:0, 3:1, 8:0, 4:1, 3:0, 5:1, 18:0, 4:1, 4:0, 4:1, 3:0, 4:1, 4:0, 4:1, 3:0, 3:1, 11:0, 4:1, 15:0, 6:1, 6:0, 5:1, 3:0, 4:1, 3:0, 4:1, 4:0, 4:1, 2:0, 5:1, 4:0, 4:1, 46:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 5:0, 3:1, 4:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 14:0, 8:1, 5:0, 5:1, 3:0, 4:1, 3:0, 3:1, 6:0, 2:1, 3:0, 4:1, 6:0, 2:1, 47:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 13:0, 4:1, 1:0, 4:1, 5:0, 4:1, 5:0, 3:1, 3:0, 3:1, 11:0, 4:1, 55:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 13:0, 4:1, 2:0, 4:1, 4:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 55:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 13:0, 3:1, 4:0, 3:1, 4:0, 3:1, 5:0, 4:1, 3:0, 4:1, 11:0, 4:1, 54:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 11:1, 5:0, 8:1, 7:0, 8:1, 49:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 10:1, 7:0, 7:1, 8:0, 7:1, 49:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 12:1, 3:0, 9:1, 9:0, 7:1, 6:0, 8:1, 49:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 12:1, 3:0, 8:1, 11:0, 7:1, 4:0, 9:1, 49:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 12:1, 3:0, 3:1, 20:0, 4:1, 2:0, 5:1, 54:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 12:1, 3:0, 3:1, 21:0, 3:1, 2:0, 4:1, 55:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 6:0, 3:1, 17:0, 4:1, 6:0, 1:1, 5:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 13:0, 1:1, 7:0, 3:1, 2:0, 4:1, 55:0"
    Data.s "52:0, 3:1, 8:0, 3:1, 5:0, 4:1, 17:0, 4:1, 5:0, 3:1, 4:0, 3:1, 5:0, 4:1, 3:0, 3:1, 11:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 12:0, 3:1, 6:0, 3:1, 2:0, 4:1, 5:0, 3:1, 9:0, 2:1, 36:0"
    Data.s "52:0, 3:1, 8:0, 4:1, 3:0, 5:1, 18:0, 4:1, 3:0, 5:1, 3:0, 4:1, 3:0, 5:1, 3:0, 3:1, 11:0, 4:1, 12:0, 3:1, 5:0, 4:1, 3:0, 3:1, 12:0, 4:1, 3:0, 5:1, 2:0, 5:1, 3:0, 5:1, 7:0, 3:1, 36:0"
    Data.s "52:0, 3:1, 8:0, 11:1, 20:0, 10:1, 4:0, 11:1, 4:0, 12:1, 2:0, 13:1, 3:0, 3:1, 5:0, 4:1, 3:0, 3:1, 13:0, 10:1, 5:0, 10:1, 7:0, 5:1, 35:0"
    Data.s "52:0, 3:1, 10:0, 8:1, 21:0, 9:1, 6:0, 9:1, 5:0, 12:1, 2:0, 13:1, 3:0, 3:1, 5:0, 4:1, 3:0, 3:1, 14:0, 8:1, 7:0, 8:1, 8:0, 5:1, 35:0"
    Data.s "52:0, 3:1, 10:0, 7:1, 23:0, 7:1, 8:0, 7:1, 6:0, 12:1, 2:0, 13:1, 3:0, 3:1, 5:0, 4:1, 3:0, 3:1, 14:0, 7:1, 9:0, 6:1, 10:0, 4:1, 35:0"
    Data.s "52:0, 3:1, 12:0, 3:1, 27:0, 3:1, 12:0, 3:1, 8:0, 12:1, 3:0, 12:1, 3:0, 3:1, 6:0, 3:1, 3:0, 3:1, 16:0, 4:1, 11:0, 3:1, 13:0, 2:1, 36:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "6:0, 7:1, 5:0, 13:1, 7:0, 5:1, 9:0, 5:1, 26:0, 3:1, 8:0, 3:1, 1:0, 4:1, 10:0, 5:1, 7:0, 3:1, 6:0, 3:1, 3:0, 12:1, 18:0, 12:1, 5:0, 8:1, 5:0, 3:1, 6:0, 3:1, 6:0, 6:1, 25:0, 4:1, 4:0"
    Data.s "5:0, 9:1, 4:0, 13:1, 7:0, 5:1, 8:0, 7:1, 25:0, 3:1, 8:0, 3:1, 1:0, 5:1, 8:0, 7:1, 5:0, 4:1, 5:0, 4:1, 3:0, 12:1, 17:0, 13:1, 5:0, 8:1, 5:0, 3:1, 5:0, 4:1, 6:0, 6:1, 25:0, 4:1, 4:0"
    Data.s "5:0, 9:1, 4:0, 13:1, 7:0, 5:1, 7:0, 9:1, 23:0, 5:1, 7:0, 10:1, 7:0, 8:1, 4:0, 4:1, 5:0, 4:1, 3:0, 12:1, 17:0, 13:1, 5:0, 8:1, 5:0, 4:1, 4:0, 4:1, 5:0, 8:1, 24:0, 4:1, 4:0"
    Data.s "6:0, 8:1, 4:0, 13:1, 7:0, 5:1, 6:0, 11:1, 22:0, 5:1, 7:0, 11:1, 4:0, 11:1, 3:0, 4:1, 5:0, 4:1, 3:0, 12:1, 18:0, 12:1, 5:0, 8:1, 5:0, 4:1, 4:0, 4:1, 3:0, 11:1, 23:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 12:0, 4:1, 6:0, 5:1, 3:0, 5:1, 21:0, 6:1, 6:0, 6:1, 1:0, 5:1, 2:0, 5:1, 3:0, 5:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 5:1, 2:0, 5:1, 3:0, 4:1, 3:0, 5:1, 22:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 12:0, 4:1, 6:0, 4:1, 6:0, 2:1, 21:0, 3:1, 1:0, 4:1, 5:0, 5:1, 4:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 5:1, 2:0, 5:1, 3:0, 3:1, 6:0, 2:1, 23:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 12:0, 4:1, 6:0, 4:1, 28:0, 4:1, 1:0, 4:1, 5:0, 5:1, 4:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 5:1, 1:0, 6:1, 3:0, 3:1, 7:0, 1:1, 23:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 12:0, 3:1, 7:0, 4:1, 28:0, 4:1, 2:0, 3:1, 5:0, 4:1, 4:0, 4:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 12:1, 3:0, 3:1, 31:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 12:0, 3:1, 7:0, 5:1, 26:0, 4:1, 4:0, 3:1, 4:0, 4:1, 3:0, 5:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 12:1, 3:0, 4:1, 30:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 23:0, 8:1, 22:0, 3:1, 5:0, 4:1, 3:0, 3:1, 1:0, 7:1, 3:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 1:0, 4:1, 1:0, 3:1, 4:0, 8:1, 25:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 25:0, 7:1, 21:0, 3:1, 5:0, 4:1, 3:0, 3:1, 1:0, 6:1, 4:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 1:0, 4:1, 1:0, 3:1, 5:0, 7:1, 25:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 25:0, 8:1, 20:0, 3:1, 5:0, 4:1, 3:0, 3:1, 1:0, 6:1, 4:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 1:0, 3:1, 2:0, 3:1, 5:0, 7:1, 25:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 27:0, 7:1, 19:0, 12:1, 3:0, 3:1, 1:0, 7:1, 3:0, 4:1, 6:0, 3:1, 2:0, 4:1, 5:0, 4:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 9:1, 25:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 30:0, 5:1, 18:0, 12:1, 3:0, 3:1, 4:0, 5:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 4:0, 5:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 4:1, 30:0, 4:1, 4:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 32:0, 3:1, 18:0, 12:1, 3:0, 3:1, 5:0, 4:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 3:1, 31:0, 3:1, 5:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 24:0, 1:1, 7:0, 3:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 6:0, 3:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 3:1, 7:0, 1:1, 31:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 23:0, 3:1, 6:0, 3:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 5:0, 4:1, 2:0, 4:1, 6:0, 3:1, 2:0, 4:1, 3:0, 6:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 3:1, 6:0, 3:1, 30:0"
    Data.s "8:0, 4:1, 11:0, 3:1, 22:0, 5:1, 3:0, 5:1, 18:0, 3:1, 5:0, 4:1, 3:0, 3:1, 4:0, 5:1, 2:0, 5:1, 3:0, 5:1, 3:0, 4:1, 1:0, 7:1, 7:0, 4:1, 26:0, 4:1, 11:0, 4:1, 7:0, 3:1, 6:0, 3:1, 3:0, 4:1, 3:0, 5:1, 22:0, 3:1, 5:0"
    Data.s "6:0, 8:1, 9:0, 3:1, 23:0, 11:1, 19:0, 3:1, 5:0, 4:1, 3:0, 11:1, 4:0, 11:1, 4:0, 12:1, 7:0, 4:1, 26:0, 4:1, 9:0, 8:1, 5:0, 3:1, 6:0, 3:1, 3:0, 11:1, 22:0, 5:1, 4:0"
    Data.s "5:0, 9:1, 9:0, 3:1, 25:0, 8:1, 20:0, 3:1, 5:0, 4:1, 3:0, 10:1, 7:0, 8:1, 6:0, 11:1, 7:0, 4:1, 26:0, 4:1, 9:0, 8:1, 5:0, 3:1, 6:0, 3:1, 5:0, 8:1, 23:0, 5:1, 4:0"
    Data.s "5:0, 9:1, 9:0, 3:1, 25:0, 7:1, 21:0, 3:1, 5:0, 4:1, 3:0, 9:1, 8:0, 7:1, 8:0, 5:1, 1:0, 4:1, 7:0, 4:1, 26:0, 4:1, 9:0, 8:1, 5:0, 3:1, 6:0, 3:1, 6:0, 6:1, 25:0, 4:1, 4:0"
    Data.s "6:0, 7:1, 10:0, 3:1, 26:0, 5:1, 22:0, 3:1, 6:0, 3:1, 3:0, 8:1, 10:0, 5:1, 10:0, 4:1, 2:0, 3:1, 7:0, 3:1, 27:0, 3:1, 10:0, 8:1, 5:0, 3:1, 6:0, 3:1, 6:0, 5:1, 27:0, 2:1, 5:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    Data.s "256:0"
    
  EndDataSection
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (153000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = --4
; EnableXP
; CompileSourceDirectory